/*
 ķ
   Program..: _DCPRC.PRG                                 
   Author...: Roger J. Donnay                            
   Notice...: (c) DONNAY Software Designs 1987-2006      
   Date.....: Dec 12, 2006                               
   Notes....: Xbase++ Printer Class                      
 Ľ
*/

#include "common.ch"
#include "gra.ch"
#include "xbp.ch"
#include "appevent.ch"
#include "dll.ch"
#include "dcdialog.ch"
#include "dcmsg.ch"
#INCLUDE "dcdir.CH"
#INCLUDE "dcprint.CH"
#INCLUDE "dcads.CH"

#if XPPVER > 1900000
  // Include the Automation Support Library
  #PRAGMA LIBRARY( "ASCOM10.LIB" )
#endif


// ****************************************************************************
// Collation Modes for XbpPrinter:setCollationMode()
// ****************************************************************************

#pragma Ansi2Oem(OFF)

#define DCPRINT_SETFONT         1
#define DCPRINT_ATSAY           2
#define DCPRINT_BOX             3
#define DCPRINT_BITMAP          4
#define DCPRINT_ATTRIBUTE       5
#define DCPRINT_LINE            6
#define DCPRINT_MARKER          7
#define DCPRINT_SETSIZE         8
#define DCPRINT_EVAL            9
#define DCPRINT_RTF            10
#define DCPRINT_STARTPAGE      11
#define DCPRINT_ENDPAGE        12
#define DCPRINT_ORIENTATION    13
#define DCPRINT_PAPERBIN       14
#define DCPRINT_FORMSIZE       15
#define DCPRINT_TEXT           16

MEMVAR oBitMap

* ---------------

CLASS DC_Printer

EXPORTED:
VAR Cargo, nProw, nPcol, lActive, nPage, nFrom, nTo, nCopies, ;
    oPS, oFont, aPageSize, nRows, nCols, cFont, aPaperSize, ;
    lFixed, lPixel, lCollate, lSelection, lToFile, lPreview, ;
    lTerminated, aBuffer, nCurrPage, cOutFile, nLastPage, ;
    lTextOnly, lAutoScale, bEventHandler, oDlg, oOkButton, ;
    nColSize, nRowSize, oDC, cPort, cComment, cPrinterName, ;
    cStatus, oAppFocus, lNextPage, lDone, nXPen, nYPen, nMargin, ;
    aViewPort, aOptions, lPrintFromPreview, oPreview, lStopEject, ;
    oStatusDlg, oStatusText, aHotKeys, nZoomIncr, nPaperBin, ;
    nFormSize, lCancelDialog, cBusyMsg, nUnits, ;
    lAutoEject, nTopMargin, nLeftMargin, lCopyLoop, lPrintGrid, ;
    nDuplexMode, nColorMode, nResolution, lTranslate, lBorder, ;
    nColDivider, oNextPage, oPrevPage, oLastPage, oFirstPage, ;
    oPrintButton, oFindButton, oPlusButton, oMinusButton, cTitle, ;
    lAcrobat, lGroups, oFirstGroup, oPrevGroup, oNextGroup, ;
    oLastGroup, nGroup, lHide, nPrintCopies, nColorBG, ;
    lExitAfterPrint, nScaleFont, lImageWriter, lExcel, ;
    aExcelSheet, nExcelPage, lCombineSheets, oBullZip, ;
    oOwner, lNoSpawn, isScrollBars, lXPSWriter, cTextFile, ;
    aColorDefault

METHOD Init, Create, SetPageSize, SetMargin, SetSize, Eval, BitMap, ;
       Destroy, Eject, Abort, Paint, PresSpace, Center, NextWord, ;
       AtSay, SetFont, SetAttr, GetFontObject, GetFontCompoundName, ;
       Qout, QQout, Box, Line, Marker, PenCoords, AddToBuffer, ;
       ReSize, Grid, ScaleFactor, Offset, ColSize, RowSize, Border, ;
       Find, ButtonConfigure, ResizeText, AddButtons, Excel, ;
       EndPage, StartPage, SetOrientation, SetPaperBin, ExcelSheet, ;
       SetFormSize, Text

#if XPPVER > 1900000
METHOD rtf
#endif

HIDDEN:
VAR lQout, oFontDlg, lAllPages, lRePaint, aBusyMsg, ;
    oDCHold, oAppWindow, cOldOutFile, aDCSize, ;
    aPPSize, aFind

ENDCLASS

* ----------------

METHOD DC_Printer:Init( aOptions, aAltOptions )

LOCAL oRet, cPrinterName, nRows, nCols, nCopies, lSelection, ;
      lCollate, lToFile, aPaperSize, ocFont, oFontDlg, nFrom, nTo, ;
      lFixed, lAllPages, lPixel, lPreview, oCrt, oXbp, oParent, ;
      nHeight, nWidth, oOwner, oAppWindow, aViewPort, oPrinter, ;
      lTextOnly, cOutFile, oOutFile, GetList := {}, lOk, nUnits, ;
      nZoomFactor, nZoomIncr, nScrollFactor, nPreviewCol, nPreviewRow, ;
      lDefault, bHandler, lEnableFont, nOutFileMode, nOrientation, cPort, ;
      cComment, cStatus, anMargin, aSize, i, cTitle, drawingArea, ;
      lStopEject, lHide, oStatic, bKeyboard, oThread, aWorkArea, ;
      nPaperBin, nFormSize, lPrintButton, lCancelDialog, cBusyMsg, ;
      aPageSize, lForceDlg, lAutoEject, nTopMargin, nLeftMargin, ;
      lCopyLoop, nDialogStyle, bErrorBlock, lPrintGrid, nDuplexMode, ;
      nColorMode, oFont, nResolution, lTranslate, lBorder, nColumn, ;
      lFindButton, aButtons, lAcrobat, aAddButtons, lGroups, nColorBG, ;
      lExitAfter, nScaleFont, cPDFPath, lImageWriter, lExcel, lCombineSheets, ;
      lNoSpawn, nTimeOut, lScrollBars, lXPSWriter, cTextFile, aColorDefault

DEFAULT aOptions TO {}
ASize( aOptions, DCPRINT_OPTIONARRAY_SIZE )

IF Valtype(aAltOptions) = 'A'
  ASize( aAltOptions, DCPRINT_OPTIONARRAY_SIZE )
  FOR i := 1 TO Len(aOptions)
    IF i $ {38,42,53} .AND. Valtype(aAltOptions[i]) == 'L' .AND. !aAltOptions[i]
      aOptions[i] := .f.
    ELSEIF Valtype(aAltOptions[i]) = 'L' .AND. aAltOptions[i]
      aOptions[i] := .t.
    ELSE
      DEFAULT aOptions[i] := aAltOptions[i]
    ENDIF
  NEXT
ENDIF

lPreview     := aOptions[15]
lTextOnly    := aOptions[19]
lDefault     := aOptions[28]
lForceDlg    := aOptions[45]
lAutoEject   := aOptions[46]
lAcrobat     := aOptions[57]
lImageWriter := aOptions[62]
lExcel       := aOptions[63]
lCombineSheets := aOptions[64]
lNoSpawn     := aOptions[66]
nTimeOut     := aOptions[67]
lXPSWriter   := aOptions[69]
aColorDefault:= aOptions[71]

DEFAULT lPreview TO .f., ;
        lAcrobat TO .f., ;
        lImageWriter TO .f., ;
        lXPSWriter TO .f., ;
        lExcel TO .f., ;
        lCombineSheets TO .f., ;
        lTextOnly TO .f., ;
        lDefault TO .f., ;
        lForceDlg TO .f., ;
        lAutoEject TO .f., ;
        lNoSpawn TO .f., ;
        aOptions[30] TO .f., ;   // Enable font
        aOptions[47] TO .f., ;   // Copy Loop
        aOptions[48] TO 2,;      // Dialog Style - XbpPrintDialog()
        nTimeout TO 0

::lActive := .f.

IF (Empty(aOptions[1]) .AND. !lDefault .AND. !lPreview .AND. ;
      !lTextOnly .AND. !lAcrobat .AND. !lImageWriter .AND. !lXPSWriter ;
      .AND. !lExcel) .OR. lForceDlg

  aOptions := DC_PrinterDialog( aOptions, @oPrinter )

  IF Empty(aOptions) .OR. Valtype(oPrinter) # 'O'
    RETURN nil
  ENDIF

ENDIF

ASize(aOptions,DCPRINT_OPTIONARRAY_SIZE)

cPrinterName  := aOptions[1]
nFrom         := aOptions[2]
nTo           := aOptions[3]
nRows         := aOptions[4]
nCols         := aOptions[5]
nCopies       := aOptions[6]
lSelection    := aOptions[7]
lCollate      := aOptions[8]
lToFile       := aOptions[9]
aPageSize     := aOptions[10]
ocFont        := aOptions[11]
oFontDlg      := aOptions[12]
lFixed        := aOptions[13]
lPixel        := aOptions[14]
lPreview      := aOptions[15]
aViewPort     := aOptions[16]
lAllPages     := aOptions[17]
cOutFile      := aOptions[18]
lTextOnly     := aOptions[19]
nUnits        := aOptions[20]
nZoomFactor   := aOptions[21]
nZoomIncr     := aOptions[22]
nScrollFactor := aOptions[23]
nPreviewCol   := aOptions[24]
nPreviewRow   := aOptions[25]
nWidth        := aOptions[26]
nHeight       := aOptions[27]
lDefault      := aOptions[28]
bHandler      := aOptions[29]
lEnableFont   := aOptions[30]
nOutFileMode  := aOptions[31]
nOrientation  := aOptions[32]
cComment      := aOptions[33]
cPort         := aOptions[34]
cStatus       := aOptions[35]
anMargin      := aOptions[36]
cTitle        := aOptions[37]
lStopEject    := aOptions[38]
lHide         := aOptions[39]
nPaperBin     := aOptions[40]
nFormSize     := aOptions[41]
lPrintButton  := aOptions[42]
lCancelDialog := aOptions[43]
cBusyMsg      := aOptions[44]
lForceDlg     := aOptions[45]
lAutoEject    := aOptions[46]
lCopyLoop     := aOptions[47]
nDialogStyle  := aOptions[48]
lPrintGrid    := aOptions[49]
nDuplexMode   := aOptions[50]
nColorMode    := aOptions[51]
nResolution   := aOptions[52]
lTranslate    := aOptions[53]
lBorder       := aOptions[54]
lFindButton   := aOptions[55]
aButtons      := aOptions[56]
lAcrobat      := aOptions[57]
aAddButtons   := aOptions[58]
lGroups       := aOptions[59]
lExitAfter    := aOptions[60]
nScaleFont    := aOptions[61]
lImageWriter  := aOptions[62]
lExcel        := aOptions[63]
lCombineSheets:= aOptions[64]
oOwner        := aOptions[65]
lNoSpawn      := aOptions[66]
lScrollBars   := aOptions[68]
lXPSWriter    := aOptions[69]
cTextFile     := aOptions[70]
aColorDefault := aOptions[71]

DEFAULT oOwner := SetAppWindow()

aWorkArea := DC_GetWorkArea()

DEFAULT nRows TO 66, ;
        nCols TO 80, ;
        lFixed TO .f., ;
        lSelection TO .f., ;
        lPixel TO .f., ;
        lCollate TO .f., ;
        lToFile TO .f., ;
        nFrom TO 0, ;
        nTo TO 0, ;
        lAllPages TO .f., ;
        lPreview TO .f., ;
        lAcrobat TO .f., ;
        lImageWriter TO .f., ;
        lXPSWriter TO .f., ;
        lTextOnly TO .f., ;
        nUnits TO GRA_PU_LOMETRIC, ;
        nZoomIncr TO .25, ;
        nScrollFactor TO 40, ;
        nPreviewCol TO aWorkArea[1], ;
        nPreviewRow TO AppDeskTop():currentSize()[2]-aWorkArea[4], ;
        nHeight TO aWorkArea[4] - aWorkArea[2], ;
        nWidth TO nHeight, ;
        lDefault TO .f., ;
        lEnableFont TO .f., ;
        nOutFileMode TO 0, ;
        cComment TO '', ;
        cPort TO '', ;
        cPrinterName TO '', ;
        cStatus TO '', ;
        anMargin TO 0, ;
        nCopies TO 1, ;
        lStopEject TO .t., ;
        lHide TO .f., ;
        lPrintButton TO .t., ;
        lCancelDialog TO .f., ;
        cBusyMsg TO '', ;
        lAutoEject TO .f., ;
        nDialogStyle TO 2, ;
        lPrintGrid TO .f., ;
        lTranslate TO .t., ;
        lBorder TO .f., ;
        lFindButton TO .f., ;
        lGroups TO .f., ;
        lExitAfter TO .f., ;
        lExcel TO .f., ;
        lCombineSheets TO .f., ;
        lNoSpawn TO .f., ;
        lScrollBars TO .t.

IF !lPreview
  lHide := .F.
ENDIF

nCopies := Val(Alltrim(Str(nCopies))) // fixes a bug in Xbase++ 1.8

IF nWidth == 0
  nHeight := aWorkArea[4] - aWorkArea[2]
  nWidth  := aWorkArea[3] - aWorkArea[1]
  DEFAULT nZoomFactor TO 1.25
ELSE
  DEFAULT nZoomFactor TO 1.0
ENDIF
IF nZoomFactor < .25
  nZoomFactor := .25
ENDIF

IF Valtype(anMargin) = 'N'
  nLeftMargin := anMargin
ELSEIF Valtype(anMargin) = 'A' .AND. Len(anMargin) >= 2
  nTopMargin := anMargin[1]
  nLeftMargin := anMargin[2]
ENDIF

DEFAULT nLeftMargin := 0, ;
        nTopMargin := 0

::nPrintCopies := 0
::oAppFocus    := SetAppFocus()
::oAppWindow   := SetAppWindow()

::aFind        := {'',0,0}
::lTranslate   := .f.
::lDone        := .f.
::cComment     := cComment
::cPrinterName := cPrinterName
::cPort        := cPort
::cStatus      := cStatus
::nMargin      := nLeftMargin
::nLeftMargin  := nLeftMargin
::nTopMargin   := nTopMargin
::aOptions     := aOptions
::nUnits       := nUnits
::nColDivider  := 8.5/11
::nCopies      := nCopies
::cTitle       := cTitle
::lAcrobat     := lAcrobat
::lImageWriter := lImageWriter
::lExcel       := lExcel
::lCombineSheets := lCombineSheets
::lNoSpawn     := lNoSpawn
::nExcelPage   := 1
::isScrollBars := lScrollBars
::lXPSWriter   := lXPSWriter
::aColorDefault:= aColorDefault

IF !Empty(::cPrinterName)
  DC_PrinterName(::cPrinterName)
ENDIF
DEFAULT ::lExcel := .f.
DEFAULT ::aHotKeys := {}
DEFAULT ::aBuffer  := {}

cPrinterName := Alltrim(cPrinterName)

::oOwner := oOwner

IF lPreview

   bKeyboard := {|a,b,o|IIF( a==xbeK_ENTER,PostAppEvent( xbeP_Activate,,,o ),nil)}

   DEFAULT cTitle := ::cPrinterName
   IF Empty(cTitle)
     cTitle := DC_LangMsg(DCMSG_PC_PRINTPRVW)
   ENDIF

   ::oDlg := XbpDialog():new( AppDeskTop(), ::oOwner, ;
         {nPreviewCol,nPreviewRow}, {nWidth,nHeight}, , .F.)

   ::oDlg:resize := {|a,b,o|::ReSize(a,b,o),::Paint(),DC_ClearEvents()}
   ::oDlg:title     := cTitle
   ::oDlg:clipParent := .t.
   ::oDlg:minButton := .F.
   ::oDlg:maxButton := .T.
   ::oDlg:taskList  := .T.
   ::oDlg:icon      := DC_IconDefault()
   ::oDlg:create()
   drawingArea := ::oDlg:drawingArea
//    drawingArea:setFontCompoundName( "8.Helv" )
   drawingArea:setFontCompoundName( Dc_BaseFont() )  // Jack Duijf 17-07-2014

   nHeight := drawingArea:currentSize()[2]
   ::oPreview := XbpPreview():new( drawingArea, , {0,0},  ;
                   {drawingArea:currentSize()[1],nHeight-20},,,, nUnits, lScrollBars )

   ::oPreview:oPrinter := self
   ::oPreview:drawBlock := nil
   ::oPreview:zoomFactor := nZoomFactor
   ::oPreview:create(,,,,,,,,::isScrollBars)
   ::oPreview:zoomIncr := nZoomIncr
   ::oPreview:nTimeOut := nTimeOut

   ::oDlg:setSize( {::oDlg:currentSize()[1]+3, ;
                    ::oDlg:currentSize()[2]} )
   DC_ClearEvents()

   ::oPS := ::oPreview:oPresSpace
   ::nUnits := ::oPS:SetPageSize()[2]

   IF Valtype(nUnits) = 'N'
     ::nUnits := nUnits
   ENDIF

   ::aPPSize := aPageSize

   IF Valtype(aPageSize) # 'A' .OR. Empty(aPageSize[1])
     ::aPageSize := ::oPS:SetPageSize()[1]
   ELSE
     ::aPageSize := aPageSize
   ENDIF

   nColumn := 0

   ::oPlusButton := XbpPushButton():new( drawingArea, , {nColumn,nHeight-20}, {30,20} )
   ::oPlusButton:caption := '+'
   ::oPlusButton:tabStop := .t.
   ::oPlusButton:create()
   ::oPlusButton:activate := {|| ::oPreview:zoom( ::oPreview:zoomFactor + nZoomIncr ) }
   ::oPlusButton:setFontCompoundName('10.Courier New Bold')
   nColumn += 30

   ::oMinusButton := XbpPushButton():new( drawingArea, , {nColumn,nHeight-20}, {30,20} )
   ::oMinusButton:caption := '-'
   ::oMinusButton:tabStop := .t.
   ::oMinusButton:create()
   ::oMinusButton:activate := {|| ::oPreview:zoom( ::oPreview:zoomFactor - nZoomIncr ) }
   ::oMinusButton:setFontCompoundName('10.Courier New Bold')
   nColumn += 30

   IF lGroups

     ::oFirstGroup := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{70,20} )
     ::oFirstGroup:caption := DC_LangMsg(DCMSG_TOP)
     ::oFirstGroup:activate := {||::nGroup := DCPRINT_GROUP_FIRST}
     ::oFirstGroup:tabStop := .t.
     ::oFirstGroup:create()
     nColumn += 70

     ::oPrevGroup := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{70,20} )
     ::oPrevGroup:caption := DC_LangMsg(DCMSG_PREV)
     ::oPrevGroup:activate := {||::nGroup := DCPRINT_GROUP_PREV}
     ::oPrevGroup:tabStop := .t.
     ::oPrevGroup:create()
     nColumn += 70

     ::oNextGroup := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{70,20} )
     ::oNextGroup:caption := DC_LangMsg(DCMSG_NEXT)
     ::oNextGroup:activate := {||::nGroup := DCPRINT_GROUP_NEXT}
     ::oNextGroup:tabStop := .t.
     ::oNextGroup:create()
     nColumn += 70

     ::oLastGroup := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{70,20} )
     ::oLastGroup:caption := DC_LangMsg(DCMSG_BOTTOM)
     ::oLastGroup:activate := {||::nGroup := DCPRINT_GROUP_LAST}
     ::oLastGroup:tabStop := .t.
     ::oLastGroup:create()
     nColumn += 70

   ENDIF

   ::oFirstPage := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{30,20} )
   ::oFirstPage:caption := "<<"
   ::oFirstPage:activate := {||::nCurrPage := 1, ::oPreview:setOrigin(0,0,.f.,.t.), ::paint()}
   ::oFirstPage:tabStop := .t.
   ::oFirstPage:create()
   ::oFirstPage:setFontCompoundName('8.Arial Bold')
   nColumn += 30

   ::oPrevPage  := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{30,20} )
   ::oPrevPage:caption := "<"
   ::oPrevPage:activate := ;
        {||::nCurrPage--,::oPreview:setOrigin(0,0,.f.,.t.),IIF(::nCurrPage<1,::nCurrPage++, ::paint())}
   ::oPrevPage:tabStop := .t.
   ::oPrevPage:create()
   ::oPrevPage:setFontCompoundName('8.Arial Bold')
   nColumn += 30

   ::oNextPage := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{30,20} )
   ::oNextPage:caption := '>'
   ::oNextPage:activate := {||::oPreview:setOrigin(0,0,.f.,.t.), ;
              IIF(::nCurrPage < ::nLastPage .OR. ::nLastPage <= 0, ;
                                  (::nCurrPage++, ;
              IIF(::nCurrPage>Len(::aBuffer),::lNextPage:=.t.,::paint())),nil)}
   ::oNextPage:create()
   ::oNextPage:setFontCompoundName('8.Arial Bold')
   nColumn += 30

   ::oLastPage := XbpPushButton():new( drawingArea,, {nColumn,nHeight-20},{30,20} )
   ::oLastPage:caption := ">>"
   ::oLastPage:activate := {|| ::nCurrPage := Len(::aBuffer), ;
                               ::oPreview:setOrigin(0,0,.f.,.t.), ;
                               ::paint(), ;
                               ::lStopEject:=.f., ;
                               IIF(::lDone, nil, ::lNextPage:=!::lGroups ) }
   ::oLastPage:tabStop := .t.
   ::oLastPage:create()
   ::oLastPage:setFontCompoundName('8.Arial Bold')
   nColumn += 30

   IF lPrintButton
     ::oPrintButton := XbpPushButtonEx():new( drawingArea, , {nColumn,nHeight-20}, {70,20} )
     ::oPrintButton:caption := DC_LangMsg(DCMSG_PRINT)
     ::oPrintButton:tabStop := .t.
     ::oPrintButton:create()
     ::oPrintButton:activate := {|| IIF(::lDone,::lPrintFromPreview := .t.,Tone(500,1)) }
     ::oPrintButton:keyboard := bKeyboard
     _HotKey(::oPrintButton:caption,::oPrintButton,::aHotKeys)
     nColumn += 70
   ENDIF

   ::oFindButton := XbpPushButtonEx():new( drawingArea, , {nColumn,nHeight-20}, ;
                    IIF(lFindButton,{70,20},{0,0}) )
   IF lFindButton
     ::oFindButton:caption := DC_LangMsg(DCMSG_FIND)
     ::oFindButton:tabStop := .t.
     ::oFindButton:activate := {|| ::Find() }
     ::oFindButton:keyboard := bKeyboard
     _HotKey(::oFindButton:caption,::oFindButton,::aHotKeys)
     nColumn += 70
   ENDIF
   ::oFindButton:create()

   ::oOkButton := XbpPushButtonEx():new( drawingArea, , {nColumn,nHeight-20}, {70,20} )
   IF !lStopEject
     ::oOkButton:caption := DC_LangMsg(DCMSG_OK)
   ELSE
     ::oOkButton:caption := DC_LangMsg(DCMSG_CANCEL)
   ENDIF
   ::oOkButton:tabStop := .t.
   ::oOkButton:create()
   ::oOkButton:activate := {|| ::lTerminated := .t. }
   ::oOkButton:keyboard := bKeyboard
   _HotKey(::oOkButton:caption,::oOkButton,::aHotKeys)

   IF !lHide
     ::oDlg:show()
     ::oDlg:setModalState(XBP_DISP_APPMODAL)
     SetAppWindow( ::oDlg )
     SetAppFocus( ::oMinusButton )
   ENDIF

  _ClearScreen( ::oPS, ::nColorBG )

  ::cPort := "Screen"
  ::cPrinterName := "Preview"
  ::cComment := 'Preview'
  ::cStatus := ''

  IF !Empty(aButtons)
    ::ButtonConfigure(aButtons)
  ENDIF

  IF Valtype(aAddButtons) == 'A'
    ::AddButtons( aAddButtons )
  ENDIF

ELSEIF lTextOnly

  IF Empty(cOutFile)
    cOutFile := Space(60)

    @ 1,1 DCSAY DC_LangMsg(DCMSG_PC_OUTFILE) GET cOutFile ;
      GETSIZE 40 SAYRIGHT ;
      GETOBJECT oOutFile ;
      VALID {||_CheckFile(@cOutFile,oOutFile)}

    DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk ENTEREXIT ;
      TITLE 'Print to File' MODAL

    IF !lOk
       RETURN nil
    ENDIF
  ENDIF

  cOutFile := Alltrim(cOutFile)
  DC_Pause(.2)

  IF nOutFileMode = 0
    IF File(cOutFile) .AND. !DC_MsgBox(,,{cOutFile + ': ' + ;
                             DC_LangMsg(DCMSG_PC_FILEMSG)},,,,.t.)
      RETURN .f.
    ENDIF
  ENDIF

  ::cOldOutFile := Set(_SET_PRINTFILE,cOutFile,nOutFileMode==2)
  SET DEVICE TO PRINT
  SetPrc(0,0)

  ::cPort := "File"
  ::cPrinterName := cOutFile
  ::cComment := 'Print to File'
  ::cStatus := ''

ELSEIF lExcel

  ::aExcelSheet := { {} }

  IF Empty(cOutFile)
    cOutFile := Pad('worksheet.xls',60)

    @ 1,1 DCSAY DC_LangMsg(DCMSG_PC_OUTFILE) GET cOutFile ;
      GETSIZE 40 SAYRIGHT ;
      GETOBJECT oOutFile

    DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk ENTEREXIT ;
      TITLE 'Excel File to Create' MODAL

    IF !lOk
       RETURN nil
    ENDIF
  ENDIF

  cOutFile := Alltrim(cOutFile)
  ::cOutFile := cOutFile

ELSE

  bErrorBlock := ErrorBlock({||_PrintError()})
  BEGIN SEQUENCE

  SET PRINTER TO

  IF Valtype(oPrinter) = 'O' .AND. oPrinter:status() > 0
    ::oDC := oPrinter
  ELSE

    IF lAcrobat .OR. Upper(cPrinterName) == 'BULLZIP PDF PRINTER'
      IF Empty(cPrinterName)
        cPrinterName := DC_PrintPreviewAcrobatOpt()[7]
      ENDIF

      IF Empty(cOutfile)
        IF !Empty(DC_PrintPreviewAcrobatOpt()[9])
          cPDFPath := DC_PrintPreviewAcrobatOpt()[9]
        ELSE
          cPDFPath := DC_CurPath() // Set(_SET_DEFAULT)
        ENDIF
        IF !(Right(cPDFPath,1) $ ':\') .AND. !Empty(cPDFPath)
          cPDFPath += '\'
        ENDIF
        IF Empty(cPDFPath)
          cPDFPath := DC_Curpath() + '\'
        ENDIF

        IF DC_PrintPreviewAcrobatOpt()[10] .AND. !Empty(::cTitle)
          ::cOutFile := cPDFPath + Strtran(Strtran(::cTitle,' ','_'),':',' ') + '_.PDF'
        ELSE
          ::cOutFile := _TempFileName(cPDFPath,".$$$.PDF")
        ENDIF
        cOutFile := ::cOutFile
      ELSE
        ::cOutFile := cOutFile
      ENDIF

      ::lToFile := .t.
      lToFile := .t.
      #if XPPVER > 1900000
      IF Upper(cPrinterName) == 'BULLZIP PDF PRINTER' .AND. ;
        AScan(XbpPrinter():new():list(),{|c|Upper(c)=='BULLZIP PDF PRINTER'})>0
        ::lToFile := .f.
        lToFile := .f.
        ::oBullZip := ActiveXObject():create('Bullzip.PDFPrinterSettings')
        ::oBullZip:SetValue('Output',::cOutFile)
        ::oBullZip:SetValue('ShowSaveAs','never')
        ::oBullZip:SetValue('ShowSettings','never')
        ::oBullZip:SetValue('ShowPdf','no')
        ::oBullZip:SetValue('ConfirmOverwrite','no')
        ::oBullZip:SetValue('ShowProgressFinished','no')
        ::oBullZip:SetValue('ShowProgress','no')
        ::oBullZip:WriteSettings()
      ENDIF
      #endif
    ELSEIF lImageWriter
      IF Empty(cPrinterName)
        cPrinterName := DC_PrintPreviewImageWriterOpt()[1]
      ENDIF
      IF Empty(cOutfile)
        IF !Empty(DC_PrintPreviewImageWriterOpt()[2])
          cPdfPath := DC_PrintPreviewImageWriterOpt()[2]
        ELSE
          cPDFPath := DC_CurPath() // Set(_SET_DEFAULT)
        ENDIF
        IF !(Right(cPDFPath,1) $ ':\')
          cPDFPath += '\'
        ENDIF
        IF DC_PrintPreviewImageWriterOpt()[3] .AND. !Empty(::cTitle)
          ::cOutFile := cPDFPath + Strtran(::cTitle,':',' ') + '_.MDI'
        ELSE
          Ferase( '*.$$$.XPS' )
          ::cOutFile := _TempFileName(cPDFPath,".$$$.MDI")
        ENDIF
        ::cOutFile := Strtran(::cOutFile,' ','_')
        cOutFile := ::cOutFile
      ELSE
        ::cOutFile := cOutFile
      ENDIF
      ::lToFile := .t.
      lToFile := .t.

    ELSEIF lXPSWriter

      IF Empty(cPrinterName)
        cPrinterName := DC_PrintPreviewXPSWriterOpt()[1]
      ENDIF
      IF Empty(cOutfile)
        IF !Empty(DC_PrintPreviewXPSWriterOpt()[2])
          cPdfPath := DC_PrintPreviewXPSWriterOpt()[2]
        ELSE
          cPDFPath := DC_CurPath() // (_SET_DEFAULT)
        ENDIF
        IF !(Right(cPDFPath,1) $ ':\')
          cPDFPath += '\'
        ENDIF
        IF DC_PrintPreviewXPSWriterOpt()[3] .AND. !Empty(::cTitle)
          ::cOutFile := cPDFPath + Strtran(::cTitle,':',' ') + '_.XPS'
        ELSE
          Ferase( '*.$$$.XPS' )
          ::cOutFile := _TempFileName(cPDFPath,".$$$.XPS")
        ENDIF
        ::cOutFile := Strtran(::cOutFile,' ','_')
        cOutFile := ::cOutFile
      ELSE
        ::cOutFile := cOutFile
      ENDIF
      ::lToFile := .t.
      lToFile := .t.
    ENDIF

    ::oDC := XbpPrinter():New( cPrinterName ):create(cPrinterName)

  ENDIF

  IF Valtype(nOrientation) = 'N'
    ::oDC:setOrientation(nOrientation)
  ENDIF

  IF Valtype(nPaperBin) = 'N'
    ::oDC:setPaperBin(nPaperBin)
  ENDIF

  IF Valtype(nCopies) = 'N'
    ::oDC:setNumCopies(nCopies)
  ENDIF
  ::nCopies := nCopies
  nCopies := ::oDC:setNumCopies()

  IF nCopies > 1
    IF lCopyLoop
      ::oDC:setNumCopies(1)
    ELSE
      ::nCopies := 1
    ENDIF
  ENDIF

  IF Valtype(nFormSize) = 'N'
    ::oDC:setFormSize(nFormSize)
  ENDIF

  IF Valtype(nDupLexMode) = 'N'
    ::oDC:setDuplexMode(nDuplexMode)
  ENDIF

  IF Valtype(nColorMode) = 'N'
    ::oDC:setColorMode(nColorMode)
  ENDIF

  IF Valtype(nResolution) $ 'AN'
    ::oDC:setResolution(nResolution)
  ENDIF

  IF lToFile .AND. !lExcel
    IF Empty(cOutFile)
      cOutFile := XBPPRN_FILE_PROMPT
    ENDIF
    ::oDC:setPrintFile(cOutFile)
  ENDIF

  END SEQUENCE

  ErrorBlock(bErrorBlock)

  ::cPrinterName := cPrinterName

  ::aPaperSize := ::oDC:paperSize()

  ::aDCSize := {::aPaperSize[5] - ::aPaperSize[3], ;
                ::aPaperSize[6] - ::aPaperSize[4]}

  ::oPS := XbpPresSpace():New()

  ::oPS:Create( ::oDC, ::aDCSize, nUnits, GRA_PU_PIXEL )

  ::cPort := cPort
  ::cPrinterName := ::oDC:devName

  ::cComment := cComment
  ::cStatus := cStatus

  IF Valtype( aPageSize ) = 'A' .AND. Len(aPageSize) = 2 .AND. Valtype(aPageSize[1]) = 'N'
    ::oPS:setPageSize( aPageSize )
  ELSEIF Valtype(::aPPSize) = 'A' .AND. Len(::aPPSize) = 2 .AND. Valtype(::aPPSize) = 'N'
    ::oPS:setPageSize( ::aPPSize )
  ENDIF

  ::aPageSize := ::oPS:setPageSize()[1]

  IF Valtype( aViewPort ) = 'A' .AND. Len(aViewPort) = 4
    ::oPS:setViewPort( aViewPort )
  ENDIF

  ::oDC:startDoc(cTitle)

ENDIF

oRet := Self

::lPreview := lPreview
::cTextFile := cTextFile
IF !lTextOnly .AND. !lExcel
  IF lPreview
    ::nColSize := ( ::aPageSize[ 1 ] * ::nColDivider  ) / nCols
  ELSE
    ::nColSize := ::aPageSize[ 1 ] / nCols
  ENDIF
  ::nRowSize := ::Offset() / nRows
ENDIF

lAllPages := lAllPages .OR. Empty(nFrom) .OR. Empty(nTo)

::nRows        := nRows
::nCols        := nCols
::lQout        := .f.
::lSelection   := lSelection
::lAllPages    := lAllPages
::nFrom        := nFrom
::nTo          := nTo
::lFixed       := lFixed
::nProw        := 0
::nPcol        := 0
::oFontDlg     := oFontDlg
::lActive      := .t.
::lPixel       := lPixel
::nPage        := 1
::nCurrPage    := 1
::lRepaint     := .f.
::lTerminated  := .f.
::lTextOnly    := lTextOnly
::cOutFile     := cOutFile
::lAutoScale   := .f.
::lNextPage    := .f.
::bEventHandler:= bHandler
::lPrintFromPreview := .f.
::lStopEject   := lStopEject
::nLastPage    := 0
::nPaperBin    := nPaperBin
::nFormSize    := nFormSize
::lCancelDialog:= lCancelDialog
::cBusyMsg     := cBusyMsg
::lAutoEject   := lAutoEject
::lPrintGrid   := lPrintGrid
::nDuplexMode  := nDuplexMode
::nColorMode   := nColorMode
::nResolution  := nResolution
::lTranslate   := lTranslate
::lBorder      := lBorder
::lGroups      := lGroups
::lHide        := lHide
::lExitAfterPrint := lExitAfter
::nScaleFont   := nScaleFont

IF ::cOldOutFile == NIL
  ::cOldOutFile  := Set(_SET_PRINTFILE)
ENDIF

IF !lTextOnly
  oFont := ::SetFont( ocFont,,.t. )
ENDIF

IF ::lCancelDialog .AND. !::lPreview
  oThread := Thread():new()
  Sleep(10)
  oThread:start({||_CancelDialog(Self)})
ENDIF

IF lPreview
  SetAppWindow(::oAppWindow)
  IF !Empty(::cBusyMsg)
    DC_Gui(.t.)
    ::aBusyMsg := DC_WaitOn(::cBusyMsg)
  ENDIF
ELSE
  ::lHide := .f.
  ::Grid()
  ::Border()
ENDIF

RETURN oRet

* -----------------

STATIC FUNCTION _CancelDialog( oPrinter )

LOCAL oXbp, mp1, mp2, nEvent, nPage := 0, cTitle

cTitle := oPrinter:cTitle // oPrinter:cPrinterName

Sleep(50)
oPrinter:oStatusDlg := XbpDialog():new(AppDeskTop(), oPrinter:oOwner,{0,0},{200,100},,.f.)
oPrinter:oStatusDlg:title := cTitle
oPrinter:oStatusDlg:minButton := .f.
oPrinter:oStatusDlg:maxButton := .f.
oPrinter:oStatusDlg:create()
oPrinter:oStatusDlg:setModalState(XBP_DISP_APPMODAL)
oPrinter:oStatusText := XbpStatic():new(oPrinter:oStatusDlg:drawingArea,,{10,40},{250,20},,.t.)
oPrinter:oStatusText:type := XBPSTATIC_TYPE_TEXT
oPrinter:oStatusText:create()
oPrinter:oStatusText:setFontCompoundName('10.Arial Bold')
oXbp := XbpPushButton():new(oPrinter:oStatusDlg:drawingArea,,{10,10},{70,20},,.t.)
oXbp:caption := DC_LangMsg(DCMSG_CANCEL)
oXbp:activate := {||oPrinter:lTerminated := .t.}
oXbp:create()
SetAppFocus(oXbp)
DC_CenterObject(oPrinter:oStatusDlg)

oPrinter:oStatusDlg:show()
oPrinter:oStatusDlg:setModalState(XBP_DISP_APPMODAL)

DC_ClearEvents()
oPrinter:oStatusDlg:toFront()
DO WHILE !oPrinter:lTerminated .AND. !oPrinter:lDone .AND. !oPrinter:lPreview
  IF oPrinter:nCurrPage # nPage
    oPrinter:oStatusText:setCaption(DC_LangMsg(DCMSG_PC_PAGE) + ;
                                  '  ' + Alltrim(Str(oPrinter:nCurrPage)))
    nPage := oPrinter:nCurrPage
    oPrinter:oStatusDlg:toFront()
  ENDIF
  nEvent := AppEvent( @mp1, @mp2, @oXbp, 10 )

  IF Valtype(oXbp) = 'O'
    oXbp:HandleEvent( nEvent, mp1, mp2 )
  ENDIF
ENDDO

IF Valtype(oPrinter:oStatusDlg) = 'O' .AND. oPrinter:oStatusDlg:status() > 0
  oPrinter:oStatusDlg:setModalState(XBP_DISP_MODELESS)
  IF oPrinter:oStatusDlg:status() == XBP_STAT_CREATE
    oPrinter:oStatusDlg:destroy()
  ENDIF
ENDIF

RETURN nil

* ------------------

STATIC FUNCTION _HotKey( cPrompt, oXbp, aHotKeys )

LOCAL cKey

cKey := IIF( '~'$cPrompt,Substr(cPrompt,At('~',cPrompt)+1,1),'')
cKey := IIF( !Empty(cKey),cKey, ;
        IIF( '&'$cPrompt,Substr(cPrompt,At('&',cPrompt)+1,1),'') )

AAdd( aHotKeys, { Asc(Lower(cKey)), oXbp } )
AAdd( aHotKeys, { Asc(Upper(cKey)), oXbp } )
AAdd( aHotKeys, { xbeK_ALT_A + Asc(Upper(cKey)) - Asc('A'), oXbp } )
AAdd( aHotKeys, { xbeK_CTRL_A + Asc(Upper(cKey)) - Asc('A'), oXbp } )

RETURN nil

* ------------------

STATIC FUNCTION _CheckFile( cOutFile, oOutFile )

LOCAL nHandle, lOk := .f., cDir, ;
      bErrorBlock := ErrorBlock({|e|_PrintError(e)})

BEGIN SEQUENCE
IF Empty(DC_Path(Alltrim(cOutFile),.t.))
  BREAK
ENDIF
IF !('.'$cOutFile)
  cOutFile := Alltrim(cOutFile)+'.PRN'
ENDIF
IF File(cOutFile)
  lOk := .t.
ELSEIF (':' $ cOutFile .OR. '\' $ cOutFile)
  cDir := DC_Path(cOutFile)
  IF Right(cDir,1)='\' .AND. Len(cDir) > 3 .AND. !(':'$cDir)
     cDir := Substr(cDir,1,Len(cDir)-1)
  ENDIF
  lOk := DC_IsDir(cDir)
ELSE
  lOk := .t.
ENDIF
END SEQUENCE
ErrorBlock(bErrorBlock)
IF !lOk
  DC_WinAlert('Cannot create file.  Invalid drive or directory')
ENDIF
cOutFile := Pad(cOutFile,60)
oOutFile:setData()

RETURN lOk

* -----------------

STATIC FUNCTION _PrintError( e )

BREAK

RETURN nil

* ----------------

METHOD DC_Printer:Create()

RETURN ( ::oPs <> Nil )

* ---------------

METHOD DC_Printer:ScaleFactor()

IF ::nUnits == GRA_PU_LOMETRIC
  RETURN 1
ELSEIF ::nUnits == GRA_PU_HIMETRIC
  RETURN 10
ELSEIF ::nUnits == GRA_PU_PIXEL
  RETURN 1.2
ELSEIF ::nUnits == GRA_PU_LOENGLISH
  RETURN .3935
ELSEIF ::nUnits == GRA_PU_HIENGLISH
  RETURN 3.935
ELSEIF ::nUnits == GRA_PU_TWIPS
  RETURN 5.66
ENDIF
RETURN 1

* ---------------

METHOD DC_Printer:Offset()

IF ::lExcel
  RETURN 0
ELSEIF ::lPreview
  RETURN (::aPageSize[2]  - ::ScaleFactor() )
ENDIF

RETURN (::aPageSize[2] * ::ScaleFactor() ) // - 100 * ::ScaleFactor()

* ---------------

METHOD DC_Printer:ColSize(lPixel)

DEFAULT lPixel := .f.

IF ::lPixel .OR. lPixel
  IF ::lPreview
    RETURN 1/::ScaleFactor()
  ENDIF
  RETURN 1
ENDIF

RETURN ::nColSize

* ----------------

METHOD DC_Printer:RowSize(lPixel)

DEFAULT lPixel := .f.

IF ::lPixel .OR. lPixel
  IF ::lPreview
    RETURN 1/::ScaleFactor()
  ENDIF
  RETURN 1
ENDIF

RETURN ::nRowSize

* ---------------

METHOD DC_Printer:SetPageSize( aPageSize )

DEFAULT aPageSize to { 2158, 2794 }    // 8 1/2 x 11


::oPS:SetPageSize( aPageSize, ::nUnits )
::aPageSize[ 1 ] := aPageSize[ 1 ]- 1 - ::aDCSize[3]
::aPageSize[ 2 ] := aPageSize[ 2 ] -1
IF ::oFont == nil
  ::SetFont( ::oFont,,.f. )
ENDIF

IF !::lTextOnly
  IF ::lPreview
    ::nColSize := ( ::aPageSize[ 1 ] * ::nColDivider ) / ::nCols
  ELSE
    ::nColSize := ::aPageSize[ 1 ] / ::nCols
  ENDIF
  ::nRowSize := ::Offset() / ::nRows
ENDIF

RETURN Self

* ---------------

METHOD DC_Printer:SetMargin( anMargin )

IF Valtype(anMargin) = 'N'
  ::nLeftMargin := anMargin
  ::nMargin := anMargin
ELSEIF Valtype(anMargin) = 'A' .AND. Len(anMargin) >= 2
  ASize(anMargin,3)
  ::nTopMargin := anMargin[1]
  ::nLeftMargin := anMargin[2]
ENDIF

DEFAULT ::nLeftMargin := 0, ;
        ::nTopMargin := 0

RETURN Self

* ----------------

METHOD DC_Printer:SetSize( nRows, nCols, bWhen )

DEFAULT nRows := 0, nCols := 0

IF !Empty(nRows) .AND. nRows > 0
  ::nRows := nRows
ENDIF
IF !Empty(nCols) .AND. nCols > 0
  ::nCols := nCols
ENDIF

::AddToBuffer( { DCPRINT_SETSIZE, ::nRows, ::nCols, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF !::lTextOnly .AND. !::lExcel
  IF ::lPreview
    ::nColSize := ( ::aPageSize[ 1 ] * ::nColDivider ) / ::nCols
  ELSE
    ::aPageSize := ::oPS:SetPageSize()[1]
    ::nColSize := ::aPageSize[ 1 ] / ::nCols
  ENDIF
  ::nRowSize := ::Offset() / ::nRows
ENDIF

RETURN Self

* ---------------

METHOD DC_Printer:Eval( bEval, bWhen )

LOCAL aOldAttr := GraSetAttrArea(::oPS), ;
      aOldMarker := GraSetAttrMarker(::oPS), ;
      aOldString := GraSetAttrString(::oPS), ;
      aOldLine := GraSetAttrLine(::oPS), ;
      oOldFont := ::oFont

::AddToBuffer( { DCPRINT_EVAL, bEval, bWhen } )

IF (::lHide .AND. !::lRepaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN self
ENDIF

Sleep(1)
Eval(bEval,self)

GraSetAttrArea(::oPS,aOldAttr)
GraSetAttrMarker( ::oPS, aOldMarker )
GraSetAttrString(::oPS,aOldString)
GraSetAttrLine(::oPS,aOldLine)
::SetFont(::oFont)

RETURN Self

* ---------------

METHOD DC_Printer:Bitmap( nR1, nC1, nR2, nC2, ncoBitMap, lAutoScale, lCenter, ;
                          nScale, lPixel, bWhen, cBitMapBuffer, cResType, cResFile, ;
                          nRasterOp, nAlign )

LOCAL aSize, aSource, aTarget, nAspect, nDll, lDestroy := .f., xResource, ;
      nColAdjust := 0, nRowAdjust := 0

IF ::lExcel
  RETURN nil
ENDIF

IF !::lAllPages .AND. !::lRepaint .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN nil
ENDIF

IF ::lTextOnly .OR. ::lTerminated
  RETURN nil
ENDIF

DEFAULT lAutoScale := ::lAutoScale, ;
        nScale := 1, ;
        nAlign := DCPRINT_ALIGN_LEFT

IF Valtype(cBitMapBuffer) == 'C'
  ncoBitMap := cBitMapBuffer
ENDIF

IF Valtype( ncoBitMap ) $ 'CNMO'

  IF Empty(cBitMapBuffer) .AND. Valtype(ncoBitMap) = 'C' .AND. !FExists(ncoBitMap)
    RETURN .f.
  ENDIF
  IF Valtype(ncoBitMap) = 'O'
    oBitMap := ncoBitMap
  ELSE
    oBitmap := XbpBitmap():new():create( ::oPS )
    lDestroy := .t.
    IF Valtype(ncoBitMap) = 'M' .OR. !Empty(cBitMapBuffer)
      IF !Empty(ncoBitMap)
        oBitMap:setBuffer(ncoBitMap)
      ELSE
        oBitMap:destroy()
        RETURN .f.
      ENDIF
    ELSEIF Valtype(ncoBitMap) = 'C'
      IF '.JPG' $ Upper(ncoBitMap) .OR. '.GIF' $ Upper(ncoBitMap)
        oBitMap:LoadFile( ncoBitMap )
      ELSEIF '.BMP' $ Upper(ncoBitMap) .OR. Empty(ncoBitMap)
        oBitMap:LoadFile( ncoBitMap )
      ELSEIF '.PNG' $ Upper(ncoBitMap)
        oBitMap:LoadFile( ncoBitMap )
      ENDIF
    ELSEIF Valtype(ncoBitMap) = 'N'
      IF Empty(cResType)
        oBitmap:Load( nil, ncoBitMap )
      ELSE
        xResource := LoadResource(ncoBitMap,cResFile,cResType)
        oBitmap:setBuffer(xResource)
      ENDIF
    ENDIF
  ENDIF

  ::AddToBuffer( { DCPRINT_BITMAP, nR1, nC1, nR2, nC2, ncoBitMap, lAutoScale, lCenter, ;
                                   nScale, lPixel, bWhen, nil, cResType, cResFile, ;
                                   nRasterOp, nAlign } )

  IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
    RETURN .f.
  ENDIF

  aSource := {0,0,oBitmap:xSize-1,oBitmap:ySize-1}

  IF Valtype(nR2) = 'N' .AND. Valtype(nC2) = 'N'
    aSize := { (nC2-nC1+1) * ::ColSize(lPixel),  ( nR2-nR1+1 ) * ::RowSize(lPixel) }
  ELSE
    aSize := { oBitMap:xSize * nScale, oBitMap:ySize * nScale }
    nC2 := nC1 + ( (oBitMap:xSize * nScale) / ::ColSize(lPixel) )
    nR2 := nR1 + ( (oBitMap:ySize * nScale) / ::RowSize(lPixel) )
  ENDIF

  aTarget := {0,0,aSize[1],aSize[2]}
  nAspect    := aSource[3] / aSource[4]

  IF lAutoScale
     IF nAspect > 1
        if nAspect > aTarget[3] / aTarget[4]
           aTarget[4] := aTarget[3] / nAspect
        else
           aTarget[3] := aTarget[4] * nAspect
        endif
     ELSE
      aTarget[3] := aTarget[4] * nAspect
    ENDIF
  ENDIF

  // Center bitmap horizontally or vertically in ::oCanvas

  DEFAULT lCenter := .T., ;
          nRasterOp := GRA_BLT_BBO_IGNORE

  IF lCenter
     IF aTarget[3] < aSize[1]-2
        nAspect := ( aSize[1]-2-aTarget[3] ) / 2
        aTarget[1] += nAspect
        aTarget[3] += nAspect
     ENDIF
     IF aTarget[4] < aSize[2]-2
        nAspect := ( aSize[2]-2-aTarget[4] ) / 2
        aTarget[2] += nAspect
        aTarget[4] += nAspect
     ENDIF
  ENDIF

  IF nAlign > 0
    IF DC_BitTest(nAlign,2) // RIGHT
      nColAdjust := -1 * oBitmap:xSize
    ELSEIF DC_BitTest(nAlign,3) // HCENTER
      nColAdjust := -1 * ( oBitmap:xSize / 2 )
    ENDIF
    IF DC_BitTest(nAlign,5) // BOTTOM
      nRowAdjust := ( oBitmap:ySize )
    ELSEIF DC_BitTest(nAlign,4) // VCENTER
      IF ::lTranslate
        nRowAdjust := (oBitmap:ySize / 2 ) - oBitmap:ySize
      ELSE
        nRowAdjust := -1 * (oBitmap:ySize / 2)
      ENDIF
    ENDIF
  ENDIF

  IF ::lTranslate
     aTarget[1] += ( (nC1+::nLeftMargin) * ::ColSize(lPixel) ) + nColAdjust
     aTarget[2] += ::Offset()-( (nR2+1+::nTopMargin ) * ::RowSize(lPixel) ) + nRowAdjust
     aTarget[3] += ( (nC1+::nLeftMargin) * ::ColSize(lPixel) ) + nColAdjust
     aTarget[4] += ::Offset()-( (nR2+1+::nTopMargin) * ::RowSize(lPixel) ) + nRowAdjust
  ELSE
     aTarget[1] += ( (nC1+::nLeftMargin) * ::ColSize(lPixel) ) + nColAdjust
     aTarget[2] += ( (nR2+1+::nTopMargin ) * ::RowSize(lPixel) ) + nRowAdjust
     aTarget[3] += ( (nC1+::nLeftMargin) * ::ColSize(lPixel) ) + nColAdjust
     aTarget[4] += ( (nR2+1+::nTopMargin) * ::RowSize(lPixel) ) + nRowAdjust
  ENDIF

  aTarget[1] := Int(aTarget[1])
  aTarget[2] := Int(aTarget[2])
  aTarget[3] := Int(aTarget[3])
  aTarget[4] := Int(aTarget[4])

  oBitmap:draw( ::oPS, aTarget, aSource, , nRasterOp )
  Sleep(1)
  IF lDestroy
    oBitmap:destroy()
  ENDIF
ELSE
  RETURN .f.
ENDIF

RETURN .t.

* ---------------

#if XPPVER > 1900000
METHOD DC_Printer:Rtf( nR1, nC1, nR2, nC2, cRtf, lPixel, bWhen )

LOCAL aTarget, oDlg, oRtf, aRect, nStartCol, nEndCol, nStartRow, nEndRow, aPaper, ;
      nScaleFactor

IF !::lAllPages .AND. !::lRepaint .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN nil
ENDIF

IF ::lTextOnly .OR. ::lExcel .OR. ::lTerminated
  RETURN nil
ENDIF

IF Valtype( cRtf ) $ 'CM'

  ::AddToBuffer( { DCPRINT_RTF, nR1, nC1, nR2, nC2, cRtf, lPixel, bWhen } )

  IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
    RETURN .f.
  ENDIF

  IF ::lPreview
    nScaleFactor := 3
  ELSE
    nScaleFactor := .85
  ENDIF

  nStartcol := Int((nC1+::nLeftMargin)*::ColSize(lPixel)) * nScaleFactor
  nEndCol := Int((nC2+::nLeftMargin)*::ColSize(lPixel))   * nScaleFactor
  nStartRow := Int(((nR1+::nTopMargin)*::RowSize(lPixel))) * nScaleFactor
  nEndRow := Int(((nR2+::nTopMargin)*::RowSize(lPixel)))   * nScaleFactor

  aRect := { nStartCol, nStartRow, nEndCol, nEndRow }

  oRtf := XbpRtf():new( , , {0,0}, {0,0} ):create()
  oRtf:loadFile(cRtf)

  if !::lPreview
      oRTF:PrintRect( ::oPS, aRect )
  else
      DCMSGBOX 'DCPRINT RTF not available in previewer'
  endif
  oRtf:Destroy()
  Sleep(1)
ELSE
  RETURN .f.
ENDIF

RETURN .t.
#endif

* --------------

METHOD DC_Printer:resizeText( cString, nWidth )

LOCAL nTextWidth, aRect, cOutString := cString, nPointer

nPointer := Len(cString)

DO WHILE .t.
  aRect := GraQueryTextBox( ::oPS, cOutString )
  nTextWidth := aRect[3,1] - aRect[1,1]
  IF nTextWidth < nWidth .OR. Empty(cOutString)
    EXIT
  ENDIF
  nPointer := Int(nPointer/2)
  cOutString := SubStr(cString,1,nPointer)
ENDDO

DO WHILE .t.
  nPointer++
  cOutString := SubStr(cString,1,nPointer)
  aRect := GraQueryTextBox( ::oPS, cOutString )
  nTextWidth := aRect[3,1] - aRect[1,1]
  IF nTextWidth > nWidth .OR. nPointer >= Len(cString)
    EXIT
  ENDIF
ENDDO

IF Len(cOutString) < Len(cString)
  cOutString := SubStr(cString, 1, nPointer-3)
  cOutString += '...'
ENDIF

return (cOutString)

* --------------

METHOD DC_Printer:find()

LOCAL GetList[0], lStatus, i, j, lNext := .f.

IF !Empty(::aFind[1])
  @ 0,0 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_FIND_NEXT) SIZE 9,1.2 ;
        ACTION {||lNext:=.t.,DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
  @ 0,11 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_FIND_NEW) SIZE 9,1.2 ;
        ACTION {||lNext:=.f.,DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
  @ 0,22 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CANCEL) SIZE 9,1.2 ;
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}
  DCREAD GUI FIT TO lStatus TITLE DC_LangMsg(DCMSG_FIND_TITLE) MODAL
  IF !lStatus
    RETURN .f.
  ELSEIF !lNext
    ::aFind[1] := ''
  ELSE
    ::aFind[3]++
  ENDIF
ENDIF

IF Empty(::aFind[1])
  ::aFind[1] := Space(30)
  @ 0,0 DCSAY DC_LangMsg(DCMSG_FIND_TEXT) GET ::aFind[1] SAYSIZE 0
  DCREAD GUI FIT ADDBUTTONS TO lStatus ENTEREXIT ;
    MODAL TITLE DC_LangMsg(DCMSG_FIND_TITLE)
  IF !lStatus .OR. Empty(::aFind[1])
    RETURN .f.
  ENDIF
  ::aFind[2] := 1 // Start Page
  ::aFind[3] := 1 // Start Item
ENDIF

BEGIN SEQUENCE
FOR i := ::aFind[2] TO Len(::aBuffer)
  FOR j := ::aFind[3] TO Len(::aBuffer[i])
    IF ::aBuffer[i,j,1] == DCPRINT_ATSAY .AND. ;
        Alltrim(Upper(::aFind[1])) $ Upper(::aBuffer[i,j,4])
      ::nPage := i
      ::nCurrPage := i
      ::aFind[2] := i // found page
      ::aFind[3] := j // found item
      ::paint(i,j)
      BREAK
    ENDIF
  NEXT
  ::aFind[3] := 1
NEXT

DC_WinAlert(::aFind[1]+DC_LangMsg(DCMSG_NOT_FOUND))

END SEQUENCE

RETURN .t.

* --------------

METHOD DC_Printer:Destroy()

IF ::lExcel
  RETURN self
ENDIF
IF ::lTextOnly
  SET DEVICE TO SCREEN
  IF !Empty(::cOldOutFile)
    Set(_SET_PRINTFILE,::cOldOutFile)
  ELSE
    SET PRINTER TO
  ENDIF
  RETURN Self
ENDIF
IF !::lPreview
  ::oDC:endDoc()
  ::oPS:configure()
  IF ::oDC:status() > 0
    ::oDC:destroy()
  ENDIF
ENDIF
IF Valtype(::oFont) = 'O' .AND. ::oFont:status() > 0
  ::oFont:destroy()
  ::oFont := nil
ENDIF
IF ::lPreview .AND. ::oDlg:status() == XBP_STAT_CREATE
  ::oDlg:setModalState(XBP_DISP_MODELESS)
  ::oDlg:destroy()
ENDIF
IF Valtype(::oAppFocus) = 'O' .AND. ::oAppFocus:status() > 0
  SetAppFocus(::oAppFocus)
ENDIF
IF Valtype(::oAppWindow) = 'O' .AND. ::oAppFocus:status() > 0
  SetAppWindow(::oAppWindow)
ENDIF
IF Valtype(::aBusyMsg) = 'A'
  DC_Impl(::aBusyMsg)
  ::aBusyMsg := NIL
ENDIF

::lActive := .f.

IF !Empty(::cPrinterName)
  DC_PrinterName( ::cPrinterName )
ENDIF

DC_PrinterObject(nil,.t.)

RETURN Self

* --------------

METHOD DC_Printer:EndPage( bWhen )

::AddToBuffer( { DCPRINT_ENDPAGE, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF Valtype(::oDC) = 'O'
  ::oDC:EndPage()
ENDIF
::Eject()

RETURN Self

* --------------

METHOD DC_Printer:StartPage( bWhen )

::AddToBuffer( { DCPRINT_STARTPAGE, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF Valtype(::oDC) = 'O'
  ::oDC:StartPage()
ENDIF

/*
::nCurrPage++
::Grid()
::Border()
::nPRow := 0
::nPCol := 0
::nXPen := nil
::nYPen := nil
*/

RETURN Self

* --------------

METHOD DC_Printer:SetOrientation( nOrientation, bWhen )

::AddToBuffer( { DCPRINT_ORIENTATION, nOrientation, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF Valtype(::oDC) = 'O'
  ::oDC:SetOrientation( nOrientation )
ENDIF

RETURN Self

* --------------

METHOD DC_Printer:SetPaperBin( nPaperBin, bWhen )

::AddToBuffer( { DCPRINT_PAPERBIN, nPaperBin, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF Valtype(::oDC) = 'O'
  ::oDC:SetPaperBin( nPaperBin )
ENDIF

RETURN Self

* --------------

METHOD DC_Printer:SetFormSize( nFormSize, bWhen )

::AddToBuffer( { DCPRINT_FORMSIZE, nFormSize, bWhen } )

IF Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self)
  RETURN self
ENDIF

IF Valtype(::oDC) = 'O' .AND. Valtype(nFormSize) == 'N'
  ::oDC:SetFormSize( nFormSize )
ENDIF

RETURN Self

* ---------------

METHOD DC_Printer:Eject( lStopGroup )

LOCAL oAppWindow := SetAppWindow(), nEvent, mp1, mp2, oXbp, bBlock
LOCAL i, aOptions, oPrinter, nCurrPage := ::nCurrPage, aViewPort := ::aViewPort, ;
      aPageSize := ::aPageSize, nRowSize := ::nRowSize, nColSize := ::nColSize, ;
      nHandle, oScrn, oSavePrinter, oAppFocus, nFound, nSeconds

IF ::lTerminated
  RETURN Self
ENDIF

IF ::lExcel
  ::nCurrPage++
  ::excelSheet()
  RETURN Self
ENDIF

DEFAULT lStopGroup := .f.

::lNextPage := .f.

IF ::lPreview
  ::oPreview:oPages:setCaption(IIF( ::lDone,AllTrim(Str(Len(::aBuffer))),'?') + ' ' + ;
    DC_LangMsg(DCMSG_PC_PAGES) )
  ::oPreview:oPagePos:setNumLimits(1,Len(::aBuffer))
  ::oPreview:oPagePos:setData()
ENDIF

Sleep(1)
IF ::lPreview .AND. !::lStopEject
  Inkey(0.1)
ENDIF

IF ::lAllPages .OR. ( ::nPage >= ::nFrom .AND. ::nPage <= ::nTo )
  IF ::lTextOnly
    EJECT
  ELSEIF !::lPreview
    ::oDC:NewPage()
    ::nCurrPage++
    ::Grid()
    ::Border()
    Sleep(1)
  ENDIF
  IF ::lTextOnly
    // do nothing
  ELSEIF ::lPreview .AND. (::lStopEject .OR. lStopGroup)
    IF Valtype(::aBusyMsg) = 'A'
      DC_Impl(::aBusyMsg)
      ::aBusyMsg := NIL
    ENDIF
    IF !::oDlg:isVisible()
      ::oDlg:show()
      ::oDlg:setModalState(XBP_DISP_APPMODAL)
      ::paint()
      SetAppWindow(::oDlg)
    ENDIF
    ::nGroup := 0
    nSeconds := Seconds()

    DO WHILE .t.

      IF ::oPreview:nTimeOut > 0 .AND. Seconds() - nSeconds > ::oPreview:nTimeOut
        PostAppEvent(xbeP_Close,,,::oDlg)
      ENDIF

      IF ::nCurrPage = 1
        IF Valtype(::oPrevPage:cargo) == 'A'
          IF !::oPrevPage:caption == ::oPrevPage:cargo[2]
            ::oPrevPage:setCaption(::oPrevPage:cargo[2])
          ENDIF
        ELSE
          ::oPrevPage:disable()
        ENDIF
        IF Valtype(::oFirstPage:cargo) == 'A'
          IF !::oFirstPage:caption == ::oFirstPage:cargo[2]
            ::oFirstPage:setCaption(::oFirstPage:cargo[2])
          ENDIF
        ELSE
          ::oFirstPage:disable()
        ENDIF
      ELSE
        IF Valtype(::oPrevPage:cargo) == 'A'
          IF !::oPrevPage:caption == ::oPrevPage:cargo[1]
            ::oPrevPage:setCaption(::oPrevPage:cargo[1])
          ENDIF
        ELSE
          ::oPrevPage:enable()
        ENDIF
        IF Valtype(::oFirstPage:cargo) == 'A'
          IF !::oFirstPage:caption == ::oFirstPage:cargo[1]
            ::oFirstPage:setCaption(::oFirstPage:cargo[1])
          ENDIF
        ELSE
          ::oFirstPage:enable()
        ENDIF
      ENDIF
      IF ( ::nCurrPage < ::nLastPage .OR. ::nLastPage <= 0 )
        IF Valtype(::oNextPage:cargo) == 'A'
          IF !::oNextPage:caption == ::oNextPage:cargo[1]
            ::oNextPage:setCaption(::oNextPage:cargo[1])
          ENDIF
        ELSE
          ::oNextPage:enable()
        ENDIF
        IF Valtype(::oLastPage:cargo) == 'A'
          IF !::oLastPage:caption == ::oLastPage:cargo[1]
            ::oLastPage:setCaption(::oLastPage:cargo[1])
          ENDIF
        ELSE
          ::oLastPage:enable()
        ENDIF
      ELSE
        IF Valtype(::oNextPage:cargo) == 'A'
          IF !::oNextPage:caption == ::oNextPage:cargo[2]
            ::oNextPage:setCaption(::oNextPage:cargo[2])
          ENDIF
        ELSE
          ::oNextPage:disable()
        ENDIF
        IF Valtype(::oLastPage:cargo) == 'A'
          IF !::oLastPage:caption == ::oLastPage:cargo[2]
            ::oLastPage:setCaption(::oLastPage:cargo[2])
          ENDIF
        ELSE
          ::oLastPage:disable()
        ENDIF
      ENDIF
      IF Valtype(::oPrintButton) == 'O'
        IF ::lDone
          IF Valtype(::oPrintButton:cargo) == 'A'
            IF !::oPrintButton:caption == ::oPrintButton:cargo[1]
              ::oPrintButton:setCaption(::oPrintButton:cargo[1])
            ENDIF
          ELSE
            ::oPrintButton:enable()
          ENDIF
        ELSE
          IF Valtype(::oPrintButton:cargo) == 'A'
            IF !::oPrintButton:caption == ::oPrintButton:cargo[2]
              ::oPrintButton:setCaption(::oPrintButton:cargo[2])
            ENDIF
          ELSE
            ::oPrintButton:disable()
          ENDIF
        ENDIF
      ENDIF
      nEvent := AppEvent( @mp1, @mp2, @oXbp, .1 )
      IF nEvent == 0
        LOOP
      ENDIF
      nSeconds := Seconds()

      IF !( bBlock := SetAppEvent(nEvent) ) == NIL
         Eval(bBlock, mp1, mp2, oXbp )
      ENDIF
      IF Valtype(oXbp) = 'O'
        IF nEvent = xbeM_Motion .AND. mp1 == NIL
          LOOP
        ENDIF
        IF Valtype(::bEventHandler) = 'B'
           nEvent := Eval(::bEventHandler,self)
           IF nEvent = DCGUI_EXIT_OK
             EXIT
           ELSEIF nEvent = DCGUI_EXIT_ABORT
             ::lTerminated := .t.
             EXIT
           ENDIF
        ENDIF
        IF nEvent == xbeP_Keyboard .AND. IsFunction('DC_DOT') .AND. ;
            mp1 == DC_DotHotKey()
          DC_ClearEvents()
          DC_Do('DC_Dot()')
        ELSEIF nEvent == xbeP_Keyboard .AND. mp1 == DC_DotHotKey()
          oScrn := ;
              DC_WaitOn('Please wait while loading DCLIP1.DLL (The Dot Prompt Engine)')
          nHandle := DllLoad('DCLIP1.DLL')
          DC_Impl(oScrn)
          IF nHandle > 0
            DC_ClearEvents()
            DC_Do('DC_Dot()')
          ENDIF
        ELSEIF nEvent == xbeM_Wheel .AND. ::isScrollBars
          IF mp2[2] < 0
            ::oPreview:vScroll({-1,XBPSB_NEXTPOS})
          ELSE
            ::oPreview:vScroll({-1,XBPSB_PREVPOS})
          ENDIF
        ELSEIF nEvent == xbeP_Keyboard
          IF mp1 == xbeK_PGDN .AND. (::nCurrPage < ::nLastPage .OR. ::nLastPage <= 0)
            ::nCurrPage++
            IF ::nCurrPage > Len(::aBuffer)
              ::lNextPage:=.t.
            ELSE
              ::paint()
            ENDIF
          ELSEIF mp1 == xbeK_PGUP .AND. ::nCurrPage > 1
            ::nCurrPage--
            ::paint()
          ELSEIF ::isScrollBars .AND. mp1 == xbeK_DOWN .AND. !(SetAppFocus()==::oPreview:oPagePos)
            ::oPreview:vScroll({-1,XBPSB_NEXTPOS})
          ELSEIF ::isScrollBars .AND. mp1 == xbeK_UP .AND. !(SetAppFocus()==::oPreview:oPagePos)
            ::oPreview:vScroll({-1,XBPSB_PREVPOS})
          ELSEIF ::isScrollBars .AND. mp1 == xbeK_RIGHT
            ::oPreview:hScroll({-1,XBPSB_NEXTPOS})
          ELSEIF ::isScrollBars .AND. mp1 == xbeK_LEFT
            ::oPreview:hScroll({-1,XBPSB_PREVPOS})
          ELSEIF mp1 == Asc('+')
            ::oPreview:zoom( ::oPreview:zoomFactor + ::oPreview:zoomIncr )
          ELSEIF mp1 == Asc('-')
            ::oPreview:zoom( ::oPreview:zoomFactor - ::oPreview:zoomIncr )
          ELSEIF mp1 == xbeK_HOME
            ::nCurrPage := 1
            ::paint()
          ELSEIF mp1 == xbeK_END
            ::nCurrPage := Len(::aBuffer)
            ::paint()
          ELSE
            nFound := AScan(::aHotKeys,{|a|a[1]==mp1})
            IF nFound > 0
              Eval(::aHotKeys[nFound,2]:activate)
            ENDIF
          ENDIF
        ELSEIF nEvent == xbeP_Close .AND. oXbp == ::oDlg
          ::lTerminated := .t.
          ::nGroup := 0
        ELSEIF !Empty(::nGroup)
          EXIT
        ENDIF
        IF nEvent # DCGUI_IGNORE
          oXbp:handleEvent( nEvent, mp1, mp2 )
        ENDIF
      ENDIF
      IF ::lPrintFromPreview
        oAppWindow := ::oAppWindow
        oAppFocus := ::oAppFocus
        nCurrPage := ::nCurrPage
        aOptions := AClone(::aOptions)
        aOptions[1]  := nil  // no printer name
        aOptions[15] := .f.  // no preview
        aOptions[28] := .f.  // not the default printer
        aOptions[39] := .f.  // no hide
        IF ::lDone
          aOptions[2] := 1  // Start page
          aOptions[3] := Len(::aBuffer) // End Page
        ENDIF
        ::oDCHold := ::oDC
        ::lAllPages := .f.
        ::oDlg:setModalState(XBP_DISP_APPMODAL)
        SetAppWindow(::oDlg)
        oPrinter := ::init( aOptions )
        IF Valtype(oPrinter) = 'O'
          DC_ClearEvents()
          FOR i := ::nFrom TO ::nTo
            ::nCurrPage := i
            ::nPage := i
            ::paint(i)
            IF i < ::nTo
              ::oDC:NewPage()
            ENDIF
            Inkey(.5)
            IF ::lTerminated
              EXIT
            ENDIF
          NEXT
          IF ::lTerminated
            ::oDC:Abort()
          ELSE
            ::oDC:EndDoc()
            ::nPrintCopies++
          ENDIF
        ENDIF
        ::oDlg:invalidateRect()
        ::oDC := ::oDCHold
        ::oPS := ::oPreview:oPresSpace
        ::aViewPort := aViewPort
        ::aPageSize := aPageSize
        ::lPreview := .t.
        ::lTerminated := ::lExitAfterPrint
        ::nCurrPage := nCurrPage
        ::nPage := nCurrPage
        ::nRowSize := nRowSize
        ::nColSize := nColSize
        ::lPrintFromPreview := .f.
        ::lAllPages := .t.
        ::oAppWindow := oAppWindow
        ::oAppFocus := oAppFocus
        ::lDone := .t.
      ENDIF

      IF ::lTerminated .OR. ::lNextPage .OR. (nEvent == xbeP_Keyboard .AND. mp1 == 27)
         ::lTerminated := ::lTerminated .OR. ( nEvent == xbeP_Keyboard .AND. mp1 == 27 )
         EXIT
      ENDIF
    ENDDO

    // ::lNextPage := .f.
    DC_ClearEvents()
    IF !::lTerminated .AND. !Empty(::cBusyMsg)
      ::aBusyMsg := DC_WaitOn(::cBusyMsg)
    ENDIF
  ENDIF
  ::nProw := 0
  ::nPcol := 0
  /*
  IF !::lTerminated .AND. !::lTextOnly
    ::SetFont( ::oFont,, .f. )
  ENDIF
  */
ENDIF
::nPage++
::AddToBuffer( { DCPRINT_SETSIZE, ::nRows, ::nCols, nil } )

IF ::lPreview
  _ClearScreen( ::oPS )
  IF ::lDone .AND. !lStopGroup
    ::destroy()
  ENDIF
ENDIF

RETURN Self

* ---------------

METHOD DC_Printer:Abort()

IF !::lPreview .AND. !::lTextOnly
  ::oDC:Abort()
ENDIF

RETURN Self

* ----------------

METHOD DC_Printer:Paint( nPage )

LOCAL i, aArray, oPSSave

DEFAULT nPage := ::nCurrPage

::lRePaint := .t.

IF nPage > Len(::aBuffer) .OR. nPage <= 0 .OR. ::lTerminated
  RETURN self
ELSEIF Empty(::aBuffer[nPage])
  RETURN self
ENDIF

IF ::lPreview
  ::oPreview:oPages:setCaption(IIF( ::lDone .OR. ::lGroups,AllTrim(Str(Len(::aBuffer))),'?') + ' ' + ;
    DC_LangMsg(DCMSG_PC_PAGES) )
  ::oPreview:oPagePos:setNumLimits(1,Len(::aBuffer))
  ::oPreview:oPagePos:setData()
  _ClearScreen( ::oPS )
ENDIF

::Grid()
::Border()

FOR i := 1 TO Len(::aBuffer[nPage])
  aArray := ::aBuffer[nPage,i]
  IF aArray[1] == DCPRINT_ATSAY
    ::lQout := aArray[7]
    IF Valtype(aArray[14])#'B' .OR. Eval(aArray[14],self)
      ::AtSay( aArray[2], aArray[3], aArray[4], aArray[5], aArray[6], ;
               aArray[8], aArray[9], aArray[10], aArray[11], aArray[12], ;
               IIF( nPage==::aFind[2].AND.i==::aFind[3],.t.,aArray[13] ),, ;
               aArray[15] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_SETFONT
    IF Valtype(aArray[4])#'B' .OR. Eval(aArray[4],self)
      ::SetFont( aArray[2], aArray[3] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_BITMAP
    IF Valtype(aArray[11])#'B' .OR. Eval(aArray[11],self)
      ::BitMap( aArray[2], aArray[3], aArray[4], aArray[5], aArray[6], ;
                aArray[7], aArray[8], aArray[9], aArray[10],, aArray[12], ;
                aArray[13], aArray[14], aArray[15] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_BOX
    IF Valtype(aArray[13])#'B' .OR. Eval(aArray[13],self)
      ::Box( aArray[2], aArray[3], aArray[4], aArray[5], ;
             aArray[6], aArray[7], aArray[8], aArray[9], ;
             aArray[10], aArray[11], aArray[12],, aArray[14])
    ENDIF
  ELSEIF aArray[1] == DCPRINT_LINE
    IF Valtype(aArray[8])#'B' .OR. Eval(aArray[8],self)
      ::Line( aArray[2], aArray[3], aArray[4], aArray[5], aArray[6], aArray[7], ;
              aArray[8], aArray[9] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_MARKER
    IF Valtype(aArray[6])#'B' .OR. Eval(aArray[6],self)
      ::Marker( aArray[2], aArray[3], aArray[4], aArray[5] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_ATTRIBUTE
    IF Valtype(aArray[6])#'B' .OR. Eval(aArray[6],self)
      ::SetAttr( aArray[2], aArray[3], aArray[4], aArray[5] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_SETSIZE
    IF Valtype(aArray[4])#'B' .OR. Eval(aArray[4],self)
      ::SetSize( aArray[2], aArray[3] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_EVAL
    IF Valtype(aArray[3])#'B' .OR. Eval(aArray[3],self)
      ::Eval( aArray[2] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_RTF
    IF Valtype(aArray[7])#'B' .OR. Eval(aArray[7],self)
      ::Rtf( aArray[2], aArray[3], aArray[4], aArray[5], aArray[6] )
    ENDIF
  ELSEIF aArray[1] == DCPRINT_STARTPAGE
    IF Valtype(aArray[2])#'B' .OR. Eval(aArray[2],self)
      ::StartPage()
    ENDIF
  ELSEIF aArray[1] == DCPRINT_ENDPAGE
    IF Valtype(aArray[2])#'B' .OR. Eval(aArray[2],self)
      ::StartPage()
    ENDIF
  ELSEIF aArray[1] == DCPRINT_ORIENTATION
    IF Valtype(aArray[3])#'B' .OR. Eval(aArray[3],self)
      ::SetOrientation(aArray[2])
    ENDIF
  ELSEIF aArray[1] == DCPRINT_PAPERBIN
    IF Valtype(aArray[3])#'B' .OR. Eval(aArray[3],self)
      ::SetPaperBin(aArray[2])
    ENDIF
  ELSEIF aArray[1] == DCPRINT_FORMSIZE
    IF Valtype(aArray[3])#'B' .OR. Eval(aArray[3],self)
      ::SetFormSize(aArray[2])
    ENDIF
  ENDIF
NEXT

::lRePaint := .f.

RETURN self

* -----------------

METHOD DC_Printer:Grid()

LOCAL i, oFont

IF ::lPrintGrid .AND. !::lTextOnly
  oFont := ::setFont("8.Courier New")
  FOR i := 1 TO ::nRows
    ::atSay( i,0, Right(Alltrim(Str(i)),1) )
    ::Line( i, 0, i, ::nCols )
  NEXT
  FOR i := 1 TO ::nCols
    ::atSay( 0, i, Right(Alltrim(Str(i)),1) )
    ::Line( 0, i, ::nRows, i )
  NEXT
  ::setFont(oFont)
ENDIF

RETURN self

* -----------------

METHOD DC_Printer:Border()

LOCAL i, oFont, oPrinter, aPaperSize, nTC, nTR, nBC, nBR

IF ::lBorder .AND. !::lTextOnly

  oPrinter := XbpPrinter():new():create()
  aPaperSize := oPrinter:paperSize()

  nTC := aPaperSize[3]
  nTR := aPaperSize[4]
  nBC := aPaperSize[5]
  nBR := aPaperSize[6]

  oPrinter:destroy()

  GraBox( ::oPS, { nTC, nTR },{ nBC, nBR  } )

ENDIF

RETURN self

* -----------------

METHOD DC_Printer:PresSpace()

RETURN ::oPS

* -----------------

METHOD DC_Printer:Center( nRow, nCol, cText )

LOCAL aStringSize, nPixWidth, nPixStart

DEFAULT nRow to ::nProw
DEFAULT nCol to ::nPcol
aStringSize := GraQueryTextBox(::oPS, cText )
nPixWidth := aStringSize[ 3, 1 ] - aStringSize[1,1]
nPixStart := nPixWidth/ 2
::AtSay( nRow, nCol - ( nPixStart/ ::nColSize )  , cText, .t. )

RETURN self

* -----------------

METHOD DC_Printer:NextWord( cText )

LOCAL cNext := '', cChar

DO WHILE Len( cText ) > 0
  cChar := Left( cText, 1 )
  IF cChar $ ( chr(13)+chr(10)+' '+chr(9) )
    IF Len( cNext ) == 0 .or. cChar == ' '
      cNext += cChar
      IF Len( cText ) == 1
        cText :=''
      ELSE
        cText := SubStr( cText, 2 )
      ENDIF
    ENDIF
    EXIT
  ENDIF
  cNext += cChar
  IF Len( cText ) == 1
    cText :=''
  ELSE
    cText := SubStr( cText, 2 )
  ENDIF
ENDDO

RETURN cNext

* -----------------

Method DC_Printer:AtSay( nRow, nCol, cText, lTrueType, lPixel, lFixed, ;
                         ocFont, aAttr, nCodePage, nAlign, lOutline, bWhen, ;
                         nWidth )

LOCAL nX, cChar, aPos, cString, aPoint, aPoint2, oOldFont, aOldAttr, ;
      aTextBox, nColAdjust := 0, nRowAdjust := 0, cFont, lRowPen, lColPen

DEFAULT lTrueType TO .f., ;
        lFixed TO .f., ;
        nAlign TO 0, ;
        lOutline TO .f.

IF ::lFixed
  lFixed := .t.
ENDIF

IF ( !::lAllPages .AND. !::lRepaint .AND. !::lNextPage .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo ) ) ;
      .OR. ::lTerminated
  RETURN nil
ENDIF

IF Valtype(nRow) = 'N' .AND. nRow < ::nProw .AND. ::lAutoEject .AND. !::lRePaint  .AND. !::lNextPage
  ::Eject()
ENDIF

cText := DC_XtoC( cText )

IF !::lTextOnly .AND. !::lExcel .AND. Valtype(ocFont) $ 'OC'
  oOldFont := GraSetFont(::oPS)
  IF Valtype(oOldFont) == 'O'
    cFont := DC_FontCompoundName( oOldFont )
    ::SetFont(ocFont, nCodePage,.f.)
  ENDIF
ENDIF

IF Valtype(nRow) = 'N'
  ::nProw := nRow
ENDIF

IF Valtype(nCol) = 'N'
  ::nPcol := nCol
ENDIF

IF ::lExcel
  ::Excel( ::nPRow, ::nPCol, cText )
  RETURN self
ENDIF

IF Valtype(nCol) = 'N'
  IF nAlign > 0
    IF !::lTextOnly
      aTextBox := GraQueryTextBox(::oPs,cText)
    ENDIF
    IF DC_BitTest(nAlign,2) // RIGHT
      IF ::lTextOnly
        nColAdjust := -1 * (Len(cText))
      ELSE
        nColAdjust := -1 * ( aTextBox[3,1] - aTextBox[2,1] )
      ENDIF
    ELSEIF DC_BitTest(nAlign,3) // HCENTER
      IF ::lTextOnly
        nColAdjust := -1 * (Len(cText)/2)
      ELSE
        nColAdjust := -1 * (( aTextBox[3,1] - aTextBox[2,1] ) / 2 )
      ENDIF
    ENDIF
    IF DC_BitTest(nAlign,1) // TOP
      IF !::lTextOnly
        nRowAdjust := ( aTextBox[3,2] - aTextBox[2,2] )
      ENDIF
    ELSEIF DC_BitTest(nAlign,4) // VCENTER
      IF !::lTextOnly
        IF ::lTranslate
          nRowAdjust := ((aTextBox[2,2]+aTextBox[3,2]) / 2 ) - (aTextBox[3,2]+aTextBox[2,2])
        ELSE
          nRowAdjust := -1 * ((aTextBox[2,2]+aTextBox[3,2]) / 2)
        ENDIF
      ENDIF
    ENDIF
  ENDIF
ENDIF

IF ::lTextOnly

  IF !Empty(cText)
     @ ::nPRow + ::nTopMargin, nColAdjust + ::nPCol + ::nLeftMargin SAY cText
  ENDIF
  ::nPcol += Len(cText)

  IF ::nProw >= ::nRows - 1 .AND. !::lRePaint .AND. ::lAutoEject .AND. !::lNextPage
    ::Eject()
  ENDIF

  RETURN self

ENDIF

IF !::lRePaint .AND. (::lPreview .OR. !Empty(::cTextFile))
  IF Valtype(ocFont) == 'O'
    ocFont := DC_FontCompoundName(ocFont)
  ENDIF
  ::AddToBuffer( { DCPRINT_ATSAY, nRow, nCol, cText, lTrueType, ;
                   lPixel, ::lQout, lFixed .OR. ::lFixed, ocFont, ;
                   aAttr, nCodePage, nAlign, lOutline, bWhen, nWidth })
ENDIF

IF (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  IF Valtype(ocFont) $ 'OC'
    oOldFont := DC_FontConfigure(oOldFont,cFont,,::oPS)
    IF oOldFont:status() == 0
      oOldFont:create()
    ENDIF
    GraSetFont(::oPS,oOldFont)
  ENDIF
  RETURN self
ENDIF

IF Empty(aAttr) .AND. !Empty(::aColorDefault)
  aAttr := DC_Color2Attr(::aColorDefault[1],::aColorDefault[2])
ENDIF

IF Valtype(aAttr) = 'A'
  aOldAttr := GraSetAttrString( ::oPS, aAttr )
ENDIF

IF !Empty(nWidth)
  cText := ::ResizeText( cText, nWidth * ::ColSize(lPixel) )
ENDIF

IF lTrueType .AND.  Len( cText ) > 0

  DO WHILE Len(cText) > 0

    cString := ::NextWord( @cText )
    IF Len( cString ) == 0
      EXIT
    ELSEIF cString == Chr(9)   //tab
      nX := ::nPcol + 8 + ::nLeftMargin
      nX := int( nX / 8 )
      ::nPcol := nX * 8
      IF ::nPcol > ::nCols
        ::nPcol := 0
      ENDIF
      GraPos( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust) * ::ColSize(lPixel)  , ;
              nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  })
    ELSEIF cString == Chr(13)
      ::nPcol := 0
      GraPos( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust) * ::ColSize(lPixel)  , ;
              nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  })
    ELSEIF cString == Chr(10)
      aPoint := GraPos( ::oPS )
      ::nProw ++
      GraPos( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust)* ::ColSize(lPixel)  ,  ;
              nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  })
    ELSE
      GraPos( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust)* ::ColSize(lPixel)  ,  ;
              nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  })
      aPoint := GraPos( ::oPS )
      aPoint2 := GraQueryTextBox(::oPS, cString )
      IF (( aPoint2[ 3, 1 ] - aPoint2[1,1]  )+ aPoint[1] ) > ;
          ( ::aPageSize[ 1 ] )
        ::nPcol := 0
        ::nProw ++
      ENDIF
      IF !::lHide .OR. ::lRepaint .OR. ::lNextPage
        GraStringAt( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust) * ::ColSize(lPixel)  ,  ;
                nRowAdjust + ::Offset()-((::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  }, cString )
      ENDIF
      aPoint := GraPos( ::oPS )
      ::nPcol := aPoint[1] / ::ColSize(lPixel)
      IF aPoint[1] >= ::aPageSize[ 1 ] - 8
        ::nProw ++
        ::nPcol := 0
        GraPos( ::oPS, { (::nPcol+::nLeftMargin+nColAdjust) * ::ColSize(lPixel)  ,  ;
                nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )  })
      ENDIF
    ENDIF

  ENDDO // Next

ELSEIF !lTruetype

  IF (lFixed .OR. ::lFixed)

    FOR nX := 1 TO Len( cText )

      cChar :=   SubStr( cText, nX, 1 )
      DO CASE
        CASE  ::lQout  .AND. cChar == Chr( 13 )
          ::nPcol := 0
        CASE  ::lQout  .AND. cChar == Chr( 10 )
          ::nProw ++
        CASE ::lQout .AND. cChar == Chr( 9 )
          ::nPcol := NextTab( ::nPcol )
        OTHERWISE
          IF ::lTranslate .AND. ( !::lHide .OR. ::lRepaint .OR. ::lNextPage)
            GraStringAt( ::oPS, { ((::nPcol+::nLeftMargin)  * ::ColSize(lPixel)) + nColAdjust, ;
               (-1*nRowAdjust) + ::Offset()-( (::nProw + 1 + ::nTopMargin) * ::RowSize(lPixel) )  },;
               cChar )
          ELSEIF !::lHide .OR. ::lRepaint .OR. ::lNextPage
            GraStringAt( ::oPS, { ((::nPcol+::nLeftMargin)  * ::ColSize(lPixel)) + nColAdjust, ;
                nRowAdjust + (::nProw + 1 + ::nTopMargin) * ::RowSize(lPixel)   },;
               cChar )
          ENDIF

          ::nPcol ++

      ENDCASE

      IF ::nPcol > ::nCols
        ::nProw ++
        ::nPcol := 0
      ENDIF

      IF ::nProw >= ::nRows - 1 .AND. ::lAutoEject
        ::Eject()
      ENDIF

    NEXT

  ELSE

    IF ! cText == NIL

      lRowPen := (nRow == NIL .AND. Valtype(::nYPen) == 'N')
      lColPen := (nCol == NIL .AND. Valtype(::nXPen) == 'N')
      IF lRowPen
        nRow := ::nYPen
      ENDIF
      IF lColPen
        nCol := ::nXPen
      ENDIF
      IF ::lTranslate
        IF !lColPen
          nCol := ((::nPcol + ::nLeftMargin ) * ::ColSize(lPixel)) + nColAdjust
        ENDIF
        IF !lRowPen
          nRow := nRowAdjust + ::Offset()-( (::nProw+1+::nTopMargin) * ::RowSize(lPixel) )
        ENDIF
      ELSE
        IF !lColPen
          nCol := ((::nPcol + ::nLeftMargin ) * ::ColSize(lPixel)) + nColAdjust
        ENDIF
        IF !lRowPen
          nRow := nRowAdjust + ((::nProw+1+::nTopMargin) * ::RowSize(lPixel))
        ENDIF
      ENDIF
      IF lOutline .AND. ( !::lHide .OR. ::lRePaint .OR. ::lNextPage )
        DrawTextBox( { nCol, nRow }, cText, ::oPS)
      ELSEIF !::lHide .OR. ::lRePaint .OR. ::lNextPage
        GraStringAt( ::oPS, { nCol, nRow }, cText )
      ENDIF

    ENDIF
    ::nPcol += Len(cText)

    IF ::nProw >= ::nRows - 1 .AND. !::lRePaint .AND. !::lNextPage .AND. ::lAutoEject .AND. ( !::lHide .OR. ::lRePaint )
      ::Eject()
    ENDIF

  ENDIF

ENDIF

aPos := GraPos( ::oPS )

IF Len(aPos) = 2
  ::nXPen := aPos[1]
  ::nYPen := aPos[2]
ENDIF

IF Valtype(ocFont) $ 'OC'
  IF Valtype(oOldFont) = 'O'
    oOldFont := DC_FontConfigure(oOldFont,cFont,,::oPS)
    IF oOldFont:status() == 0
      oOldFont:create()
    ENDIF
    GraSetFont(::oPS,oOldFont)
  ENDIF
ENDIF

IF Valtype(aAttr) = 'A'
  IF aOldAttr == NIL
    aOldAttr := Array(GRA_AS_COUNT)
  ENDIF
  IF aOldAttr[GRA_AS_HORIZALIGN] == NIL
    aOldAttr[GRA_AS_HORIZALIGN] := GRA_HALIGN_LEFT
  ENDIF
  IF aOldAttr[GRA_AS_VERTALIGN] == NIL
    aOldAttr[GRA_AS_VERTALIGN] := GRA_VALIGN_BASE
  ENDIF
  GraSetAttrString( ::oPS, aOldAttr )
ENDIF

RETURN self

* --------------------

*****************************************
* Draws character string with border    *
*****************************************
STATIC PROCEDURE DrawTextBox( aPenPos, cString, oPS )

   LOCAL aTextBox, aLeftTop, aLeftBottom, aRightTop, aRightBottom

   aTextBox        := GraQueryTextBox( oPS, cString )

   aLeftTop        := aTextBox[1]               // relative coordinates for
   aLeftBottom     := aTextBox[2]               // the four corner points of the
   aRightTop       := aTextBox[3]               // parallelogram
   aRightBottom    := aTextBox[4]

   aLeftTop[1]     += aPenPos[1]                // convert relative coordinates
   aLeftTop[2]     += aPenPos[2]                // to absolute coordinates
   aLeftBottom[1]  += aPenPos[1]
   aLeftBottom[2]  += aPenPos[2]
   aRightTop[1]    += aPenPos[1]

   aRightTop[2]    += aPenPos[2]
   aRightBottom[1] += aPenPos[1]
   aRightBottom[2] += aPenPos[2]
   // draw border
   GraLine( oPS, aLeftTop, aRightTop )
   GraLine( oPS, NIL, aRightBottom )
   GraLine( oPS, NIL, aLeftBottom )
   GraLine( oPS, NIL, aLeftTop )
   // draw character string
   GraStringAt( oPS, aPenPos, cString )

RETURN

* --------------------

METHOD DC_Printer:SetFont( ocFont, nCodePage, lAddToBuffer, bWhen )

LOCAL ocOldFont, oFont, cCompoundName, cFamily, nPointSize, cNominalPointSize, ;
      cFamilyName

IF ::lTextOnly .OR. ::lExcel .OR. ::lTerminated
   RETURN nil
ENDIF

oFont := GraSetFont(::oPS)

DEFAULT lAddToBuffer := .t.

IF Empty(ocFont)
  ocFont := IIF( ::lPreview,'12.Courier New','12.Courier New' )
ENDIF

IF !Empty(::oFont)
  ocOldFont := ::oFont
ELSE
  ocOldFont := ::cFont
ENDIF

IF Valtype( ocFont ) = 'C' .AND. Valtype(oFont) == 'O'

  IF ('Courier' $ ocFont) .AND. !('Courier New' $ ocFont)
    ocFont := Strtran(ocFont,'Courier','Courier New')
  ENDIF

  IF !Empty(::nScaleFont)
    cNominalPointSize := Alltrim(Str(Round(::nScaleFont*Val(ocFont),0)))
    cFamilyName := Substr(ocFont,At('.',ocFont))
    ocFont := cNominalPointSize + cFamilyName
  ENDIF

  oFont := DC_FontConfigure( oFont, ocFont, nCodePage, ::oPS )

ELSEIF Valtype( ocFont ) = 'O'

  oFont := ocFont

ENDIF

IF lAddToBuffer
  IF Valtype(ocFont) == 'O'
    ocFont := DC_FontCompoundName( ocFont )
  ENDIF
  ::AddToBuffer( { DCPRINT_SETFONT, ocFont, nCodePage, bWhen } )
ENDIF

IF (::lHide .AND. !::lRepaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN ocOldFont
ENDIF

IF Empty(oFont)
  oFont := DC_FontConfigure( oFont, ocFont, nCodePage, ::oPS )
ENDIF

IF oFont:status() == 0
  oFont:create()
ENDIF

IF oFont:status() == 0
   oFont:create()
ENDIF

GraSetFont( ::oPS, oFont )
::oFont := oFont
::cFont := DC_FontCompoundName( oFont )

IF Empty(ocOldFont)
  ocOldFont := ocFont
ENDIF

RETURN ocOldFont

* ---------------

METHOD DC_Printer:SetAttr( aString, aLine, aArea, aMarker, bWhen )

LOCAL aAttr

IF ::lTerminated .OR. ::lTextOnly .OR. ::lExcel
  RETURN self
ENDIF

::AddToBuffer( { DCPRINT_ATTRIBUTE, aString, aLine, aArea, aMarker, bWhen } )

IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN self
ENDIF

IF Valtype(aString) = 'A'
  GraSetAttrString( ::oPS, aString )
ENDIF

IF Valtype(aLine) = 'A'
  GraSetAttrLine( ::oPS, aLine )
ENDIF

IF Valtype(aArea) = 'A'
  GraSetAttrArea( ::oPS, aArea )
ENDIF

IF Valtype(aMarker) = 'A'
  GraSetAttrMarker( ::oPS, aMarker )
ENDIF

RETURN self

* --------------

Method DC_Printer:GetFontObject()

RETURN GraSetFont(::oPS)

* ---------------

Method DC_Printer:GetFontCompoundName()

RETURN ::cFont

* ----------------

METHOD DC_Printer:Qout( acText, cPicture, nCol, aAttr, bWhen )

LOCAL i, cText

::lQout := .t.
::nProw ++
IF Valtype(nCol) = 'N'
  ::nPcol := nCol
ELSE
  ::nPcol := 0
ENDIF

IF Valtype(acText) # 'A'
  acText := { acText }
ENDIF

FOR i := 1 TO Len(acText)
  cText := acText[i]
  IF !( cText = NIL .OR. ( Valtype(cText) = 'C' .AND. Len(cText)=0 ) )
    IF !Empty(cPicture)
      ::AtSay( ::nProw, ::nPcol, Transform(cText,cPicture),,,,,aAttr,,,,bWhen  )
    ELSE
      ::AtSay( ::nProw, ::nPcol, cText,,,,,aAttr,,,,bWhen )
    ENDIF
  ENDIF
  ::nPcol++
NEXT

::lQout := .f.

RETURN self

* ----------------

METHOD DC_Printer:QQout( cText, lUsePenCoords, cPicture, nCol, aAttr, bWhen )

DEFAULT lUsePenCoords := DC_PrinterUsePenCoords()



::lQout := .t.
IF !( cText = NIL .OR. ( Valtype(cText) = 'C' .AND. Len(cText)=0 ) )
  IF lUsePenCoords
    ::AtSay( nil, nil, ;
             IIF( Empty(cPicture),cText,Transform(cText,cPicture)),,,,,aAttr,,,,bWhen )
  ELSE
    ::AtSay( ::nProw, IIF( Valtype(nCol)=='N',nCol,::nPcol), ;
             IIF( Empty(cPicture),cText,Transform(cText,cPicture)),,,,,aAttr,,,,bWhen )
  ENDIF
ELSE
  ::nPcol++
ENDIF
::lQout := .f.

RETURN self

* ----------------

METHOD DC_Printer:Box( nTR, nTC, nBR, nBC , nFill, nHrad, nVrad, ;
                       aAreaAttr, lPixel, aLineAttr, nLineWidth, bWhen, ;
                       nGrayPct )

LOCAL aOldAreaAttr, aOldLineAttr, i, aAreaRGB, nGrayLevel

DEFAULT nLineWidth := 1

IF !::lAllPages .AND. !::lRepaint .AND. !::lNextPage .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN self
ENDIF

IF ::lTextOnly .OR. ::lTerminated .OR. ::lExcel
  RETURN self
ENDIF

::AddToBuffer( { DCPRINT_BOX, nTR, nTC, nBR, nBC, nFill, nHrad, ;
                 nVrad, aAreaAttr, lPixel, aLineAttr, nLineWidth, ;
                 bWhen, nGrayPct } )

IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN self
ENDIF

IF Valtype(nGrayPct) == 'N'
  nGrayLevel := INT(254 - (nGrayPct * 2.54))
  aAreaRGB := {nGrayLevel,nGrayLevel,nGrayLevel}
  DEFAULT nFill := 3
ENDIF

IF Valtype(aAreaAttr) = 'A'
  IF !Empty(nGrayPct) .AND. !Empty(aAreaAttr[GRA_AA_COLOR])
    aAreaAttr[GRA_AA_COLOR] := GraMakeRGBColor(aAreaRGB)
  ENDIF
  aOldAreaAttr := GraSetAttrArea( ::oPS, aAreaAttr )
ELSEIF !Empty(nGrayPct)
  aAreaAttr := Array(GRA_AA_COUNT)
  aAreaAttr[GRA_AA_COLOR] := GraMakeRGBColor(aAreaRGB)
  aOldAreaAttr := GraSetAttrArea( ::oPS, aAreaAttr )
ENDIF

IF Valtype(aLineAttr) = 'A'
  aOldLineAttr := GraSetAttrLine( ::oPS, aLineAttr )
ENDIF

FOR i := 0 TO nLineWidth-1
  IF ::lTranslate
    GraBox( ::oPS, { ((nTC+::nLeftMargin)*::ColSize(lPixel))-i, ;
            (::Offset()-((nTR+::nTopMargin)*::RowSize(lPixel)))+i },;
     { (((nBC+::nLeftMargin)*::ColSize(lPixel))+1)+i, ;
       (::OffSet()-(((nBR+::nTopMargin)*::RowSize(lPixel))+1)-i) },;
        nFill, nHrad, nVrad )
  ELSE
    GraBox( ::oPS, { ((nTC+::nLeftMargin)*::ColSize(lPixel))-i , ;
            ((nTR+::nTopMargin)*::RowSize(lPixel))+i },;
     { (((nBC+::nLeftMargin)*::ColSize(lPixel))+1)+i,;
        (((nBR+::nTopMargin)*::RowSize(lPixel))+1)-i },;
        nFill, nHrad, nVrad )
  ENDIF
NEXT

IF Valtype(aAreaAttr) = 'A'
  IF aOldAreaAttr == NIL
    aOldAreaAttr := Array(GRA_AA_COUNT)
  ENDIF
  GraSetAttrArea( ::oPS, aOldAreaAttr )
ENDIF

IF Valtype(aLineAttr) = 'A'
  IF aOldLineAttr == NIL
    aOldLineAttr := Array(GRA_AA_COUNT)
  ENDIF
  GraSetAttrLine( ::oPS, aOldLineAttr )
ENDIF

RETURN self

* ----------------

METHOD DC_Printer:Line( nTR, nTC, nBR, nBC , aAttr, lPixel, bWhen, nLineWidth )

LOCAL aOldAttr

IF !::lAllPages .AND. !::lRepaint .AND. !::lNextPage .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN self
ENDIF

IF ::lTextOnly .OR. ::lTerminated .OR. ::lExcel
  RETURN self
ENDIF

::AddToBuffer( { DCPRINT_LINE, nTR, nTC, nBR, nBC, aAttr, lPixel, bWhen, nLineWidth } )

IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN self
ENDIF

IF Valtype(nLineWidth) == 'N'
  DEFAULT aAttr := Array(GRA_AL_COUNT)
  aAttr[GRA_AL_WIDTH] := nLineWidth
ENDIF

IF Valtype(aAttr) = 'A'
  aOldAttr := GraSetAttrLine( ::oPS, aAttr )
ENDIF

IF ::lTranslate
  GraLine( ::oPS, {(nTC+::nLeftMargin) * ::ColSize(lPixel) , ;
                  ::Offset()-( (nTR+::nTopMargin) * ::RowSize(lPixel) ) },;
   { ( nBC+::nLeftMargin ) * ::ColSize(lPixel), ;
     ::Offset() - ( ( nBR + ::nTopMargin ) * ::RowSize(lPixel) ) } )
ELSE
  GraLine( ::oPS, {(nTC+::nLeftMargin) * ::ColSize(lPixel) , ;
                  (nTR+::nTopMargin) * ::RowSize(lPixel)  },;
   { ( nBC+::nLeftMargin ) * ::ColSize(lPixel), ( nBR + ::nTopMargin ) * ::RowSize(lPixel) } )

ENDIF

IF Valtype(aAttr) = 'A'
  IF aOldAttr == NIL
    aOldAttr := Array(GRA_AL_COUNT)
  ENDIF
  GraSetAttrLine( ::oPS, aOldAttr )
ENDIF

RETURN self

* ---------------

METHOD DC_Printer:Marker( nTR, nTC, aAttr, lPixel, bWhen )

LOCAL aOldAttr

IF !::lAllPages .AND. !::lRepaint .AND. !::lNextPage .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN self
ENDIF

IF ::lTextOnly .OR. ::lTerminated .OR. ::lExcel
  RETURN self
ENDIF

::AddToBuffer( { DCPRINT_MARKER, nTR, nTC, aAttr, lPixel, bWhen } )

IF (::lHide .AND. !::lRePaint .AND. !::lNextPage) .OR. (Valtype(bWhen) == 'B' .AND. !Eval(bWhen,self))
  RETURN self
ENDIF

IF Valtype(aAttr) = 'A'
  aOldAttr := GraSetAttrMarker( ::oPS, aAttr )
ENDIF

IF ::lTranslate
  GraMarker( ::oPS, {(nTC+::nLeftMargin) * ::ColSize(lPixel) , ;
                    ::Offset()-( (nTR+::nTopMargin) * ::RowSize(lPixel) ) } )
ELSE
  GraMarker( ::oPS, {(nTC+::nLeftMargin) * ::ColSize(lPixel) , ;
                     (nTR+::nTopMargin) * ::RowSize(lPixel) } )
ENDIF

IF Valtype(aAttr) = 'A'
  IF aOldAttr == NIL
    aOldAttr := Array(GRA_AM_COUNT)
  ENDIF
  GraSetAttrMarker( ::oPS, aOldAttr )
ENDIF

RETURN self

* ----------------

METHOD DC_Printer:Text( cText, nLeftMargin, nTopMargin, nRightMargin, nBottomMargin, ;
                        nRowSpace, nMaxHeight, cFont )

LOCAL i, nXPen, nPageBottom, nPageWidth

IF !::lAllPages .AND. !::lRepaint .AND. !::lNextPage .AND. ( ::nPage < ::nFrom .OR. ::nPage > ::nTo )
  RETURN self
ENDIF

::AddToBuffer( { DCPRINT_TEXT, cText, nLeftMargin, nTopMargin, nRightMargin, ;
                 nBottomMargin, nRowSpace, nMaxHeight, cFont } )

IF (::lHide .AND. !::lRePaint .AND. !::lNextPage)
  RETURN self
ENDIF

DEFAULT nLeftMargin := 50, ;
        nTopMargin := 50, ;
        nBottomMargin := 50, ;
        nRightMargin := 50, ;
        nRowSpace := 40

nPageBottom := ::aPageSize[2] - nBottomMargin
nPageWidth := ::aPageSize[1] - nRightMargin

FOR i := 1 TO Len(cText)
  IF Valtype(nMaxHeight) == 'N' .AND. ::nProw > nMaxHeight
    EXIT
  ENDIF
  nXPen := nil
  IF cText[i] == Chr(13)
  ELSEIF cText[i] == Chr(10)
    ::nPRow += nRowSpace
    IF ::nProw > nPageBottom
      ::eject()
      ::nProw := nTopMargin
    ENDIF
    ::nXPen := nil
    ::nPCol := nLeftMargin
    nXPen := nLeftMargin
  ELSE
    IF EndOfLine(cText,i,self,nPageWidth)
      ::nPRow += nRowSpace
      ::nPCol := nLeftMargin
      ::nXPen := nil
      nXPen := nLeftMargin
      DO WHILE cText[i] == ' '
        i++
      ENDDO
    ENDIF
    IF ::nProw > nPageBottom
      ::eject()
      ::nPRow := nTopMargin
      ::nPCol := nLeftMargin
      ::nXPen := nil
      nXPen := nLeftMargin
    ENDIF
    ::atSay(::nProw, nXPen, cText[i])
  ENDIF
NEXT

RETURN self

* -----------

STATIC FUNCTION EndOfLine( cText, i, oPrinter, nPageWidth )

LOCAL nEnd, cWord, nWordLengthInPixels, aRect

IF cText[i] = ' '
  nEnd := At(' ',cText,i+1)
  cWord := Substr( cText, i+1, nEnd - i)
  aRect := GraQueryTextBox( oPrinter:oPs, cWord )
  nWordLengthInPixels := aRect[3,1] - aRect[1,1]
  IF Valtype(oPrinter:nXPen)=='N' .AND. ;
      oPrinter:nXPen + nWordLengthInPixels >= nPageWidth
    RETURN .t.
  ENDIF
ENDIF

RETURN .f.

* ---------------

METHOD DC_Printer:PenCoords( nTR, nTC, lPixel )

IF ::lTranslate
  RETURN { (nTC+::nLeftMargin) * ::ColSize(lPixel), ;
           ::Offset() -( (nTR+1+::nTopMargin) * ::RowSize(lPixel) ) }
ENDIF

RETURN { (nTC+::nLeftMargin) * ::ColSize(lPixel), ;
         (nTR+1+::nTopMargin) * ::RowSize(lPixel) }

* ---------------

METHOD DC_Printer:AddToBuffer( aArray )

IF ::lRePaint .OR. (!::lPreview .AND. Empty(::cTextFile)) .OR. ::lTerminated .OR. ::lExcel
  RETURN self
ENDIF

IF ::nPage < 1
  ::nPage := 1
ENDIF
IF Len( ::aBuffer ) < ::nPage
  ASize( ::aBuffer, ::nPage )
ENDIF
IF Valtype(::aBuffer[::nPage]) # 'A'
  ::aBuffer[::nPage] := {}
ENDIF

AADD( ::aBuffer[::nPage], AClone(aArray) )

RETURN self

* ---------------

METHOD DC_Printer:Excel( nRow, nCol, xData )

nRow++
nCol++

IF nRow > Len(::aExcelSheet[::nExcelPage])
  ASize(::aExcelSheet[::nExcelPage],nRow)
ENDIF
IF ::aExcelSheet[::nExcelPage,nRow] == NIL
  ::aExcelSheet[::nExcelPage,nRow] := Array(::nCols+1)
ENDIF
IF nCol > Len(::aExcelSheet[::nExcelPage,nRow])
  ASize(::aExcelSheet[::nExcelPage,nRow],nCol)
ENDIF

::aExcelSheet[::nExcelPage,nRow,nCol] := xData

RETURN self

* ---------------

METHOD DC_Printer:ExcelSheet( cName )

IF ::lExcel .AND. !Empty(::aExcelSheet[::nExcelPage])
  ::nExcelPage++
  AAdd(::aExcelSheet,{})
ENDIF

RETURN self

* ---------------

METHOD DC_Printer:ReSize( aOldSize, aNewSize, oDlg )

LOCAL aChildren, i, oXbp

IF aOldSize[1] == aNewSize[1] .AND. aOldSize[2] == aNewSize[2]
  RETURN self
ENDIF

::oPreview:XbpStatic:setSize({oDlg:drawingArea:currentSize()[1], ;
                              oDlg:drawingArea:currentSize()[2]-20})

aChildren := oDlg:drawingArea:childList()
FOR i := 1 TO Len(aChildren)
  oXbp := aChildren[i]
  IF oXbp:isderivedfrom('XbpPushButton') .AND. aOldSize[2] # aNewSize[2]
    oXbp:setPos( {oXbp:currentPos()[1],oDlg:drawingArea:currentSize()[2]-20})
    oXbp:invalidateRect()
  ENDIF
NEXT

_ClearScreen( ::oPS )

::oPreview:setSize(::oPreview:currentSize())
DC_ClearEvents()
::oPreview:setup()

RETURN self

* ---------------

METHOD DC_Printer:ButtonConfigure( aButtons )

LOCAL i, nWidth, nHeight, xCaption, aObjects

DEFAULT aButtons := {}
ASize(aButtons,13)

aObjects := ;
{::oPlusButton,;
 ::oMinusButton,;
 ::oFirstPage,;
 ::oPrevPage,;
 ::oNextPage,;
 ::oLastPage,;
 ::oPrintButton,;
 ::oFindButton,;
 ::oOkButton,;
 ::oFirstGroup,;
 ::oPrevGroup,;
 ::oNextGroup,;
 ::oLastGroup}

::oDlg:drawingArea:lockUpdate(.t.)

FOR i := 1 TO Len(aButtons)
  IF !Empty(aButtons[i])
    ASize(aButtons[i],3)
    nWidth := aButtons[i,1]
    nHeight := aButtons[i,2]
    xCaption := aButtons[i,3]
    IF Valtype(xCaption) = 'A'
      ASize(xCaption,2)
      aObjects[i]:cargo := xCaption
      xCaption := xCaption[1]
    ENDIF
    DEFAULT nWidth := aObjects[i]:currentSize()[1]
    DEFAULT nHeight := aObjects[i]:currentSize()[2]
    aObjects[i]:setSize({nWidth,nHeight})
    IF !Empty(xCaption)
      aObjects[i]:caption := xCaption
    ENDIF
    aObjects[i]:configure()
  ENDIF
NEXT
FOR i := 2 TO Len(aObjects)
  IF aObjects[i] == NIL
    LOOP
  ENDIF
  aObjects[i]:setPos({aObjects[i-1]:currentPos()[1]+aObjects[i-1]:currentSize()[1],;
                      aObjects[i]:currentPos()[2]})
NEXT

::oDlg:drawingArea:lockUpdate(.f.)
::oDlg:configure()

RETURN self

* ---------------

METHOD DC_Printer:AddButtons( aButtons )

LOCAL i, nRow, nCol, oButton

::oDlg:drawingArea:lockUpdate(.t.)

nCol := ::oOKButton:currentPos()[1] + ::oOKButton:currentSize()[1]
nRow := ::oOKButton:currentPos()[2]

FOR i := 1 TO Len(aButtons)
  ASize(aButtons[i],5)
  DEFAULT aButtons[i,1] := 70
  DEFAULT aButtons[i,2] := 20
  oButton := XbpPushButton():new(::oOkButton:setParent(),,{nCol,nRow},{aButtons[i,1],aButtons[i,2]})
  oButton:caption := aButtons[i,3]
  oButton:activate := aButtons[i,4]
  oButton:create()
  nCol += aButtons[i,1]
NEXT

::oDlg:drawingArea:lockUpdate(.f.)
::oDlg:configure()

RETURN self

* ---------------

FUNCTION DC_PrinterDialog( aOptions, oPrinter )

LOCAL oDLg, oGroup1, oGroup2, oGroup3, oGroup4, aReturn := {}, cPrinterName, ;
      aList, cDefault, lSelected := .f., bAction, oTo, oFrom, ;
      lDump := .f., lAllPages , nFrom := 0, nTo := 0, lEnableFont, ;
      nCopies, lCollate := .f., nX, oType, oStatus , lToFile  := .f., ;
      aHelp := {}, oPop2, oWhere, oComment, GetList := {}, a, ;
      GetOptions, nRadio := 1, ocFont, aViewPort, cOutFile, lTextOnly, ;
      oFontDlg, cFont, oFocus := SetAppFocus(), lRowCol := .f., ;
      aPaperSize, lIsFixed := .f., cFontName, oFontName, lPreview, ;
      lSelection, lCopies := .f., lFixed, nRows, nCols, lPixel, ;
      nUnits, lOk, nOrientation, cComment, cPort, cStatus, nMargin, ;
      cTitle, lStopEject, lHide, nPaperBin, nFormSize, lPrintButton, ;
      lCancelDialog, cBusyMsg, i, aPageSize, lSelect, mp1, mp2, nEvent, ;
      oXbp, oThread, lForceDlg, lAutoEject, bErrorBlock, lCopyLoop, ;
      nDialogStyle, lPrintGrid, nDuplexMode, nColorMode, nResolution, ;
      lTranslate, lBorder, lFindButton, aButtons, lAcrobat, aAddButtons, ;
      lGroups, bRadioAction, lExitAfter, nScaleFont, lImageWriter, lXPSWriter

DEFAULT aOptions := {}
ASize(aOptions,DCPRINT_OPTIONARRAY_SIZE)

cPrinterName  := aOptions[1]
nFrom         := aOptions[2]
nTo           := aOptions[3]
nRows         := aOptions[4]
nCols         := aOptions[5]
nCopies       := aOptions[6]
lSelection    := aOptions[7]
lCollate      := aOptions[8]
lToFile       := aOptions[9]
aPageSize     := aOptions[10]
ocFont        := aOptions[11]
oFontDlg      := aOptions[12]
lFixed        := aOptions[13]
lPixel        := aOptions[14]
lPreview      := aOptions[15]
aViewPort     := aOptions[16]
lAllPages     := aOptions[17]
cOutFile      := aOptions[18]
lTextOnly     := aOptions[19]
nUnits        := aOptions[20]
lEnableFont   := aOptions[30]
nOrientation  := aOptions[32]
cComment      := aOptions[33]
cPort         := aOptions[34]
cStatus       := aOptions[35]
nMargin       := aOptions[36]
cTitle        := aOptions[37]
lStopEject    := aOptions[38]
lHide         := aOptions[39]
nPaperBin     := aOptions[40]
nFormSize     := aOptions[41]
lPrintButton  := aOptions[42]
lCancelDialog := aOptions[43]
cBusyMsg      := aOptions[44]
lForceDlg     := aOptions[45]
lAutoEject    := aOptions[46]
lCopyLoop     := aOptions[47]
nDialogStyle  := aOptions[48]
lPrintGrid    := aOptions[49]
nDuplexMode   := aOptions[50]
nColorMode    := aOptions[51]
nResolution   := aOptions[52]
lTranslate    := aOptions[53]
lBorder       := aOptions[54]
lFindButton   := aOptions[55]
aButtons      := aOptions[56]
lAcrobat      := aOptions[57]
aAddButtons   := aOptions[58]
lGroups       := aOptions[59]
lExitAfter    := aOptions[60]
nScaleFont    := aOptions[61]
lImageWriter  := aOptions[62]
lXPSWriter    := aOptions[69]

oPrinter := XbpPrinter():New(cPrinterName)

aList := oPrinter:List()

IF Empty(aList)
   DC_WinAlert('There are no Printers Installed!')
   RETURN nil
ENDIF

oPrinter:create(cPrinterName)

cDefault := oPrinter:devName

DEFAULT cPrinterName to cDefault

IF AScan( aList, cPrinterName ) == 0
  cPrinterName := cDefault
ENDIF

IF Empty(cPrinterName)
  cPrinterName := aList[1]
ENDIF

oPrinter:destroy()
oPrinter := XbpPrinter():New():create(cPrinterName)
IF oPrinter:status() # 1  // The selected printer is not valid
  FOR i := 1 TO Len(aList)
    cPrinterName := aList[i]
    oPrinter:destroy()
    oPrinter := XbpPrinter():New():create(cPrinterName)
    IF oPrinter:status() == 1 // Good printer
      EXIT
    ENDIF
  NEXT
ENDIF

//Retrieves or sets the size of output media ( Letter, A4, A3, etc.)
IF Valtype(nFormSize) = 'N'
  oPrinter:setFormSize(nFormSize)
ENDIF

// sets the duplex mode
IF Valtype(nDuplexMode) = 'N'
  oPrinter:setDuplexMode(nDuplexMode)
ENDIF

// sets the duplex mode
IF Valtype(nColorMode) = 'N'
  oPrinter:setColorMode(nColorMode)
ENDIF

// sets the print resolution
IF Valtype(nResolution) $ 'AN'
  oPrinter:setResolution(nResolution)
ENDIF

//Selects the bin to load the paper form
IF Valtype(nPaperBin) = 'N'
  oPrinter:setPaperbin(nPaperBin)
ENDIF

DEFAULT nCopies := 1
nCopies := Val(Alltrim(Str(nCopies))) // fixes a bug in Xbase++ 1.8

// Set the number of copies
IF Valtype(nCopies) = 'N'
  oPrinter:setNumCopies(nCopies)
ENDIF

//Retrieves or sets the paper orienation for a printer
IF Valtype(nOrientation) = 'N'
  oPrinter:setOrientation(nOrientation)
ENDIF

IF nDialogStyle = 2

  oDlg := XbpPrintDialog():new()
  oDlg:enablePrintToFile := .t.
  oDlg:enableNumCopies := .t.
  oDlg:enableCollate := .t.
  oDlg:numCopies := nCopies

  IF !Empty(nFrom) .AND. !Empty(nTo)
    oDlg:pageRange := { nFrom, nTo }
    oDlg:pageRangeSelected := { nFrom, nTo }
  ENDIF
  oDlg:create()
  lSelect := .f.

/*
  oPrinter := oDlg:display()

  IF oDlg:status() > 0
    oDlg:configure()
    oDlg:destroy()
  ENDIF
*/

  oThread := Thread():new()
  Sleep(10)
  oThread:start({||oPrinter := _PrinterDialog(oDlg,oPrinter,@lSelect)})

  DO WHILE !lSelect
    nEvent := AppEvent(@mp1,@mp2,@oXbp,10)
    IF Valtype(oXbp) = 'O'
      oXbp:handleEvent(nEvent,mp1,mp2)
    ENDIF
  ENDDO

  Sleep(10)

  IF Valtype(oPrinter) # 'O'
    SetAppFocus(oFocus)
    DC_ClearEvents()
    RETURN nil
  ENDIF

  bErrorBlock := ErrorBlock({|e|_PrintError(e)})
  BEGIN SEQUENCE
  aOptions[1] := oPrinter:devName
  aOptions[2] := oDlg:pageRangeSelected[1]
  IF Empty(aOptions[2])
    aOptions[2] := nFrom
  ENDIF
  aOptions[3] := oDlg:pageRangeSelected[2]
  IF Empty(aOptions[3])
    aOptions[3] := nTo
  ENDIF
  aOptions[6] := oPrinter:setNumCopies()
  aOptions[8] := oPrinter:setCollationMode() == XBPPRN_COLLATIONMODE_ON
  // aOptions[17] := oDlg:enableNumCopies
  aOptions[32] := oPrinter:setOrientation()
  aOptions[40] := oPrinter:setPaperBin()
  aOptions[41] := oPrinter:setFormSize()
  aOptions[50] := oPrinter:setDuplexMode()
  aOptions[51] := oPrinter:setColorMode()
  aOptions[52] := oPrinter:setResolution()
  SetAppFocus(oFocus)
  END SEQUENCE
  ErrorBlock(bErrorBlock)
  RETURN aOptions

ENDIF

IF Valtype(ocFont) = 'C' .AND. Empty(ocFont) .AND. Valtype(lEnableFont) # 'L'
  lEnableFont := .t.
ENDIF

IF Valtype(nRows) # 'N' .OR. Valtype(nCols) # 'N'
  lRowCol := .t.
  nRows := 66
  nCols := 80
ENDIF

IF Valtype(lFixed) # 'L'
  lIsFixed := .t.
  lFixed := .f.
ENDIF

IF Valtype(nCopies) # 'N'
  lCopies := .t.
  nCopies := 1
ENDIF

DEFAULT nRows TO 66, ;
        nCols TO 80, ;
        lFixed TO .f., ;
        lSelection TO .f., ;
        lPixel TO .f., ;
        lCollate TO .f., ;
        lToFile TO .f., ;
        nFrom TO 1, ;
        nTo TO 1, ;
        lPreview TO .f., ;
        lTextOnly TO .f., ;
        nUnits TO GRA_PU_LOMETRIC, ;
        lEnableFont TO .t., ;
        nCopies TO 1

IF Valtype(ocFont) = 'C'
  cFontName := ocFont
ELSEIF Valtype(ocFont) = 'U'
  cFontName := 'Courier New, 12 Point'
  ocFont := '12.Courier New'
ENDIF

// lAllPages := .t.

bAction := ;
  { |mp1, mp2, obj, a| obj:XbpSLE:getData(), ;
    IIF(Valtype(oPrinter)='O'.AND.oPrinter:Status()>0,oPrinter:Destroy(),nil),;
    oPrinter := XbpPrinter():New( ),;
    oPrinter:create( cPrinterName ),;
    oType:SetCaption( cPrinterName ),;
    cPort := WhereToPrint( cPrinterName ), ;
    oWhere:SetCaption( cPort ),;
    a := DC_TokenArray(DC_LangMsg(DCMSG_PC_READY),';'), ;
    cStatus := IIF( cPrinterName == cDefault, a[1] + ':','') + ;
                    IIF(IsPrinter( cPort ), a[2],'?') ,;
    oStatus:SetCaption(cStatus), ;
    cComment := GetPrinterComment( cPrinterName ), ;
    oComment:SetCaption( cComment ) }

cPort := WhereToPrint( cPrinterName )
cComment := GetPrinterComment( cPrinterName )
a := DC_TokenArray(DC_LangMsg(DCMSG_PC_READY),';')
cStatus := IIF( cPrinterName == cDefault, a[1] + '; ','') + ;
                IIF(IsPrinter( cPort ), a[2],'?')


* ---- Group 1 (Printer) ---- *

@ 245, 10 DCGROUP oGroup1 SIZE 416,130 CAPTION DC_LangMsg(DCMSG_PC_PRINTER)

@ 95, 10 DCSAY DC_LangMsg(DCMSG_PC_NAME)+':' PARENT oGroup1 SAYSIZE 60,12

@ 10, 75 DCCOMBOBOX cPrinterName LIST aList ;
         PARENT oGroup1 SIZE 230,100 ;
         TYPE XBPCOMBO_DROPDOWNLIST ;
         EVAL { |o| o:ItemMarked := bAction, ;
                    o:ItemSelected := bAction }

@ 88, 315 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_PC_PROPERTIES) ;
  SIZE 90, 23 PARENT oGroup1 ;
  ACTION {|m1,m2, oButton| oDlg:disable(), ;
                           oPrinter:Setupdialog(),;
                           oDlg:enable(), ;
                           SetAppFocus( oButton )  }

@ 70, 10 DCSAY DC_LangMsg(DCMSG_PC_STATUS) + ':' SAYSIZE 60,15 PARENT oGroup1

@ 70, 75 DCSAY cStatus SAYSIZE 240,15  ;
         SAYOBJECT oStatus PARENT oGroup1

@ 50, 10 DCSAY DC_LangMsg(DCMSG_PC_TYPE) + ':' SAYSIZE 60, 15 PARENT oGroup1

@ 50, 75 DCSAY cPrinterName SAYSIZE 200,15 SAYOBJECT oType PARENT oGroup1

@ 30, 10 DCSAY DC_LangMsg(DCMSG_PC_WHERE) + ':' SAYSIZE 60,15 PARENT oGroup1

@ 30, 75 DCSAY cPort PARENT oGroup1 SAYOBJECT oWhere SAYSIZE 339, 15

@ 10, 10 DCSAY DC_LangMsg(DCMSG_PC_COMMENT) + ':' PARENT oGroup1 SAYSIZE 60,15

@ 10, 75 DCSAY cComment PARENT oGroup1 SAYOBJECT oComment SAYSIZE 250,15

* ---- Group 2 (Print Range) ---- *

@ 135, 10 DCGROUP oGroup2 CAPTION DC_LangMsg(DCMSG_PC_PRINTRANGE) SIZE 210, 100

bRadioAction := {|oRadio|lAllPages := nRadio == 1, ;
                         lSelection := nRadio == 3, ;
                         DC_GetRefresh(GetList)}

@ 62, 5 DCRADIO nRadio PARENT oGroup2 SIZE 60,20 PROMPT DC_LangMsg(DCMSG_PC_ALL) ;
        VALUE 1 ;
        ACTION bRadioAction

@ 36,5 DCRADIO nRadio PARENT oGroup2 SIZE 60,20 PROMPT DC_LangMsg(DCMSG_PC_PAGES) ;
        VALUE 2 ;
        ACTION bRadioAction

@ 10,5 DCRADIO nRadio PARENT oGroup2 SIZE 60,20 PROMPT DC_LangMsg(DCMSG_PC_SELECTED) ;
        VALUE 3 ;
        ACTION bRadioAction

lSelection := .f.

@ 38,55 DCSAY DC_LangMsg(DCMSG_PC_FROM) + ':' PARENT oGroup2 SAYSIZE 30,15 SAYRIGHT

@ 38,87 DCGET nFrom GETSIZE 40,20 GETOBJECT oFrom PARENT oGroup2 ;
        WHEN {||nRadio == 2} PICT '999'

@ 38,127 DCSAY DC_LangMsg(DCMSG_PC_TO) + ':' SAYSIZE 30,15 PARENT oGroup2 SAYRIGHT

@ 38,159 DCGET nTo GETSIZE 40,20 GETOBJECT oTo PARENT oGroup2 ;
         WHEN {||nRadio == 2} VALID {||nTo >= nFrom} PICT '999'

* ---- Group 3 (Copies) ---- *

@ 135, 230 DCGROUP oGroup3 CAPTION DC_LangMsg(DCMSG_PC_COPIES) + ':' SIZE 196, 100

@ 62, 10 DCSAY DC_LangMsg(DCMSG_PC_NMBRCOPIES) + ':' PARENT oGroup3 SAYSIZE 99,15

@ 62,110 DCSPINBUTTON nCopies SIZE 50,20 PARENT oGroup3 ;
         LIMITS 1,20 ;
         EVAL { |o| IIF(lCopies,nil,o:disable()) }

@ 10,270 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_OK) SIZE 70,23 ;
         ACTION {|| lSelected := .t.,  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList), ;
                    lDump := .t. }

@ 10,346 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CANCEL) SIZE 70,23 ;
         ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList), lDump := .t. }


* ---- Group 4 (Misc) ---- *

@ 55, 10 DCGROUP oGroup4 CAPTION DC_LangMsg(DCMSG_PC_PAGE) SIZE 416, 70

@ 30, 10 DCSAY DC_LangMsg(DCMSG_PC_ROWS) + ':' SAYRIGHT SAYSIZE 50,15 PARENT oGroup4

@ 30, 70 DCSPINBUTTON nRows LIMITS 0,100 PARENT oGroup4 ;
         SIZE 50,20 ;
         EVAL { |o| IIF(lRowCol,nil,o:disable()) }

@ 37, 140 DCSAY DC_LangMsg(DCMSG_PC_FONT) + ':' PARENT oGroup4 SAYSIZE 30,15

@ 37, 175 DCSAY cFontName SAYSIZE 200,15 ;
         SAYOBJECT oFontName PARENT oGroup4

@ 10, 10 DCSAY DC_LangMsg(DCMSG_PC_COLUMNS) + ':' SAYRIGHT SAYSIZE 50,15 PARENT oGroup4

@ 10, 70 DCSPINBUTTON nCols LIMITS 0,200 PARENT oGroup4 ;
         SIZE 50,20 ;
         EVAL { |o| IIF(lRowCol,nil,o:disable()) }

@ 10, 135 DCCHECKBOX lFixed PROMPT DC_LangMsg(DCMSG_PC_NPCOLUMNS) ;
         PARENT oGroup4  // SIZE 250,15

@ 10, 305 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_PC_FONT) ;
  SIZE 90, 23 PARENT oGroup4 ;
  ACTION {|m1,m2, oButton| ocFont := ;
            ChooseFont(ocFont,@oFontDlg,@cFontName,cPrinterName), ;
            oFontName:SetCaption(cFontName) } ;
  WHEN {||lEnableFont}

DCGETOPTIONS                               ;
      NAME 'PRINTER'                       ;
      TITLE DC_LangMsg(DCMSG_PC_PRINTER)   ;
      WINDOWHEIGHT 410                     ;
      WINDOWWIDTH 438                      ;
      PIXEL                                ;
      NOTRANSLATE                          ;
      EVAL { |o| o:MinSize := { 438,410 }, ;
                 o:MaxSize := { 438,410 }, ;
                 o:MinButton := .f.,       ;
                 o:MaxButton := .f. }

DEFAULT cTitle := DC_LangMsg(DCMSG_PC_PRINTER)

DCREAD GUI                                 ;
  EXPRESS ;
  OPTIONS GetOptions                       ;
  TITLE cTitle                             ;
  PARENT @oDlg                             ;
  MODAL                                    ;
  TO lOk

IF lSelected .AND. lOk

  bErrorBlock := ErrorBlock({|e|_PrintError(e)})
  BEGIN SEQUENCE
  cPrinterName := oPrinter:devName
  lCollate     := oPrinter:setCollationMode() == XBPPRN_COLLATIONMODE_ON
  nOrientation := oPrinter:setOrientation()
  nPaperBin    := oPrinter:setPaperBin()
  nFormSize    := oPrinter:setFormSize()
  nDuplexMode  := oPrinter:setDuplexMode()
  nColorMode   := oPrinter:setColorMode()
  nResolution  := oPrinter:setResolution()
  END SEQUENCE
  ErrorBlock(bErrorBlock)

  IF Valtype(aPageSize) # 'A'
    aPageSize := oPrinter:papersize()
  ENDIF

  aReturn := { cPrinterName, nFrom, nTo, nRows, nCols, nCopies , ;
               lSelection, lCollate, lToFile, aPageSize, ocFont, ;
               oFontDlg, lFixed, lPixel, lPreview, aViewPort, lAllPages, ;
               cOutFile, lTextOnly, nUnits, nil, nil, nil, nil, nil, ;
               nil, nil, nil, nil, nil, nil, nOrientation, cComment, ;
               cPort, cStatus, nMargin, cTitle, lStopEject, lHide, ;
               nPaperBin, nFormSize, lPrintButton, lCancelDialog, cBusyMsg, ;
               lForceDlg, lAutoEject, lCopyLoop, nDialogStyle, lPrintGrid, ;
               nDuplexMode, nColorMode, nResolution, lTranslate, lBorder, ;
               lFindButton, aButtons, lAcrobat, aAddButtons, lGroups, ;
               lExitAfter, nScaleFont, lImageWriter, lXPSWriter }

ELSE

  IF Valtype(oPrinter)='O'.AND.oPrinter:status()>0
    oPrinter:Destroy()
  ENDIF
  oPrinter := nil

ENDIF

SetAppFocus( oFocus )

RETURN aReturn

* ----------------

STATIC FUNCTION _PrinterDialog( oDlg, oPrinter, lSelect )

oPrinter := oDlg:display(oPrinter)
lSelect := .t.

RETURN oPrinter

* ----------------

STATIC FUNCTION WhereToPrint( cPrinterName )

LOCAL cRet
IF !Empty( cPrinterName )
  cRet := PrinterPort(cPrinterName)
ENDIF
IF cRet == Nil
  cRet := 'Unknown?'
ELSE
  cRet := SubStr( cRet, 1, len( cRet) -1 )
ENDIF

RETURN cRet

* -----------------

STATIC FUNCTION GetPrinterComment( cPrinterName )

LOCAL cRet

IF !empty( cPrinterName )
  cRet := PrinterComment( cPrinterName )
ENDIF

IF cRet == Nil
  cRet := 'Unknown?'
ELSE
  cRet := SubStr( cRet, 1, len( cRet) -1 )
ENDIF

RETURN cRet

* ----------------

STATIC FUNCTION PrinterSize( oDC, lPreview, aPageSize )

LOCAL aCoords

IF lPreview
  RETURN aPageSize
ELSE
  aCoords := oDC:PaperSize()
ENDIF

RETURN { aCoords[5]-1 - aCoords[3],   aCoords[ 6 ] - aCoords[ 4 ] - 1   }

* ---------------

STATIC FUNCTION NextTab( nCol )

LOCAL nNewCol := nCol+1 , nDiv

nNewCol += 8
nDiv := int( nNewCol /8 )
nNewCol := nDiv * 8

RETURN ( nNewCol - 1 )

* ----------------

STATIC FUNCTION QueryRegistry ( nHKEYHandle, cKeyName, cEntryName )

LOCAL cName := "", rc
LOCAL nNameSize
LOCAL nKeyHandle
LOCAL nValueType

nKeyHandle := 0

IF RegOpenKeyExA(nHKEYHandle, cKeyName,0, KEY_QUERY_VALUE, @nKeyHandle) = 0

  nValueType  := 0
  nNameSize  := 0
  RegQueryValueExA(nKeyHandle, cEntryName, 0, @nValueType, 0, @nNameSize)
  IF nNameSize > 0

    cName := space( nNameSize )

    rc := RegQueryValueExA(nKeyHandle, cEntryName,;
                           0, @nValueType, @cName, @nNameSize)

  ENDIF

  RegCloseKey( nKeyHandle)

ENDIF

RETURN cName

* ----------------

STATIC FUNCTION PrinterComment( cPrinter )

//returns comment information placed in printer driver by user

LOCAL nHKey      := HKEY_LOCAL_MACHINE
LOCAL cKeyName   := ;
   "System\CurrentControlSet\Control\Print\Printers\" + cPrinter
LOCAL cEntryName := "Description"

RETURN QueryRegistry(nHKey, cKeyName, cEntryName)

* ----------------

STATIC FUNCTION PrinterPort( cPrinter )

//returns actual port ie, LPT1:, LPT2:,
//ServerName\DeviceName, COM3: etc., etc..

LOCAL nHKey      := HKEY_LOCAL_MACHINE
LOCAL cKeyName   := "System\CurrentControlSet\Control\Print\Printers\"+cPrinter
LOCAL cEntryName := "Port"

RETURN QueryRegistry(nHKey, cKeyName, cEntryName)

* ----------------

FUNCTION DC_PrinterOn ( aOptions, aAltOptions )

LOCAL oPrinter

/*
oPrinter := DC_PrinterObject()

IF Valtype(oPrinter) = 'O' .AND. oPrinter:isderivedfrom('DC_PRINTER') ;
      .AND. oPrinter:lActive
  oPrinter:Destroy()
  DC_PrinterObject( nil,.t. )
ENDIF
*/

oPrinter := DC_Printer():new( aOptions, aAltOptions )

IF oPrinter:lActive
  DC_PrinterObject( oPrinter, .t. )
ELSE
  DC_PrinterObject( nil, .t. )
ENDIF

RETURN oPrinter

* ----------------

FUNCTION DC_PrinterOk ( oPrinter )

DEFAULT oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O' .AND. Upper(oPrinter:ClassName()) = 'DC_PRINTER'
  DEFAULT oPrinter:lTerminated := .f.
  RETURN !oPrinter:lTerminated .AND. oPrinter:lActive
ENDIF
RETURN .t.

* ----------------

FUNCTION DC_PrinterRow ( oPrinter )

DEFAULT oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O' .AND. Upper(oPrinter:ClassName()) = 'DC_PRINTER'
  RETURN oPrinter:nPRow
ENDIF
RETURN 0

* ----------------

FUNCTION DC_PrinterCol ( oPrinter )

DEFAULT oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O' .AND. Upper(oPrinter:ClassName()) = 'DC_PRINTER'
  RETURN oPrinter:nPCol
ENDIF
RETURN 0

* ----------------

FUNCTION DC_PrinterOff ( oPrinter, nPage, lOkCancel )

LOCAL oThread, lStatus := .t., i, cOldFile

IF Valtype(oPrinter) # 'O'
  oPrinter := DC_PrinterObject( oPrinter )
ENDIF

IF Valtype(oPrinter) = 'O' .AND. !oPrinter:lExcel

  oPrinter:lDone := .t.
  IF oPrinter:lPreview .AND. !Empty(oPrinter:aBuffer)
    oPrinter:nLastPage := Len(oPrinter:aBuffer)
    IF Valtype(nPage) == 'N'
      oPrinter:nCurrPage := nPage
    ELSEIF !oPrinter:oDlg:isVisible()
      oPrinter:nCurrPage := 1
    ELSE
      oPrinter:nCurrPage := Len(oPrinter:aBuffer)
    ENDIF
    IF oPrinter:oOkButton:nShortCut != NIL
      SetAppEvent( oPrinter:oOkButton:nShortCut, )
    ENDIF
    oPrinter:oOkButton:setCaption(DC_LangMsg(DCMSG_EXIT))
    oPrinter:oOKButton:SetShortCut()
    _HotKey(oPrinter:oOkButton:caption,oPrinter:oOkButton,oPrinter:aHotKeys)
    oPrinter:lStopEject := .t.
    oPrinter:eject()
  ENDIF

  oPrinter:Destroy()

  IF oPrinter:lAcrobat
    IF DC_PrintPreviewAcrobatOpt()[1] == 1
      oThread := Thread():new()
      Sleep(10)
      oThread:start({||DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel,oPrinter:lNoSpawn)})
    ELSE
      lStatus := DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel,oPrinter:lNoSpawn)
    ENDIF
  ELSEIF oPrinter:lXPSWriter
    lStatus := DC_PrintPreviewXPSWriter(oPrinter:cOutFile,oPrinter:cTitle,oPrinter:lNoSpawn)
  ENDIF

ELSEIF Valtype(oPrinter) == 'O' .AND. oPrinter:lExcel

  DC_Array2Excel(@oPrinter:cOutfile, oPrinter:aExcelSheet,,.t.,.f.,.f.,.t., oPrinter:lCombineSheets )

  DC_SpawnUrl(oPrinter:cOutFile)

ENDIF

IF Valtype(oPrinter) == 'O' .AND. Valtype(oPrinter:oBullZip) == 'O'
  oPrinter:oBullZip:destroy()
ENDIF

IF Valtype(oPrinter) == 'O' .AND. !Empty(oPrinter:cTextFile)
  cOldFile := Set(_SET_PRINTFILE,oPrinter:cTextFile)
  SET DEVICE TO PRINT
  SetPrc(0,0)
  //roger
  oPrinter:lTextOnly := .t.
  FOR i := 1 TO Len(oPrinter:aBuffer)
    oPrinter:paint(i)
  NEXT
  SET DEVICE TO SCREEN
  IF !Empty(cOldFile)
    Set(_SET_PRINTFILE,cOldFile)
  ELSE
    SET PRINTER TO
  ENDIF
ENDIF

RETURN lStatus

* ---------------

FUNCTION DC_PrinterGroupEject ( oPrinter, nPage, nGroup )

oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O'
  IF oPrinter:lPreview
    DEFAULT nPage := 1
    DEFAULT nGroup := oPrinter:nGroup
    oPrinter:nLastPage := Len(oPrinter:aBuffer)
    IF Valtype(nPage) == 'N'
      oPrinter:nCurrPage := nPage
    ELSEIF !oPrinter:oDlg:isVisible()
      oPrinter:nCurrPage := 1
    ELSE
      oPrinter:nCurrPage := Len(oPrinter:aBuffer)
    ENDIF
    IF oPrinter:oOkButton:nShortCut != NIL
      SetAppEvent( oPrinter:oOkButton:nShortCut, )
    ENDIF
    oPrinter:oOkButton:setCaption(DC_LangMsg(DCMSG_EXIT))
    oPrinter:oOKButton:SetShortCut()
    _HotKey(oPrinter:oOkButton:caption,oPrinter:oOkButton,oPrinter:aHotKeys)
    oPrinter:nCurrPage := nPage
    oPrinter:paint()
    oPrinter:lDone := .t.
    oPrinter:eject(.t.)
    oPrinter:lDone := .f.
    oPrinter:aBuffer := {}
    oPrinter:nCurrPage := 1
    oPrinter:nPage := 1
  ENDIF
ENDIF

RETURN oPrinter:nGroup

* ----------------

FUNCTION DC_PrinterObject ( oObject, lPost )

LOCAL nThreadID := ThreadID(), oOldPrinter
STATIC aPrinter[0]

IF Len(aPrinter) < nThreadID
  ASize(aPrinter,nThreadID)
ENDIF

oOldPrinter := aPrinter[nThreadID]

lPost := IIF( Valtype(lPost)='L',lPost,.f. )

IF Valtype(oObject) = 'O' .AND. oObject:isDerivedFrom('DC_Printer')
  IF lPost
    aPrinter[nThreadId] := oObject
    oOldPrinter := oObject
  ELSE
    oOldPrinter := oObject // aPrinter[nThreadId]
  ENDIF
ELSEIF lPost
  aPrinter[nThreadId] := oObject
ENDIF

RETURN oOldPrinter

* ---------------

STATIC FUNCTION ChooseFont ( ocFont, oFontDlg, cFontName, cPrinterName )

LOCAL oXbp := SetAppFocus(), cFamilyName := '', oPS, oPrinter, bErrorBlock, ;
      ocSaveFont := ocFont

oPS := XbpPresSpace():New()
oPrinter := XbpPrinter():New():create(cPrinterName)
oPS:Create( oPrinter )
oFontDlg := XbpFontDialog():New(AppDeskTop(),,,oPS)
oFontDlg:create()

bErrorBlock := ErrorBlock({||_FontError()})
BEGIN SEQUENCE
ocFont := oFontDlg:display( XBP_DISP_APPMODAL )

IF Valtype(ocFont) = 'O'

  cFontName := Alltrim(Str(ocFont:nominalPointSize)) + '.' + ;
               ocFont:compoundname + ;
               IIF(ocFont:Underscore,' Underscore','')

  ocFont := cFontName

ELSE
  ocFont := ocSaveFont
ENDIF
oPS:destroy()
oPrinter:destroy()
oFontDlg:destroy()

END SEQUENCE
ErrorBlock(bErrorBlock)
SetAppFocus( oXbp )

RETURN ocFont

* -----------------

STATIC PROCEDURE _FontError()
BREAK
RETURN

* -----------------

FUNCTION DC_PrintFile( cFileName, lPreview, cFont, aOptions, lStripEscape )

LOCAL GetList := {}, oDirs, oFileName, lOk, nHandle, cText, oPrinter, ;
      cDirectory, oFiles, aTokens, nPageRows, nPageCols, lFixed, lEject, ;
      oScrn, lGui, nZoomFactor, lEjectAfterPrint

lOk := .t.
lStripEscape := .f.
IF Pcount() = 0 .OR. Empty(cFileName)

   lOk := .f.
   cFileName := Pad(IIF(Valtype(cFileName)='C',cFileName,'' ),70)
   lPreview := IIF(Valtype(lPreview)='L',lPreview,.f.)
   @ 3,2 DCSAY 'Enter name of file to Print'

   @ 4,2 DCGET cFileName GETSIZE 53 GETOBJECT oFileName ;
         VALID {|o|o:=_ValidFile(cFileName), ;
                   DC_GetRefresh(GetList), ;
                   o}
   @ 5.5,2 DCDIRTREE ;
      DIRS oDirs VAR cDirectory ;
      FILES oFiles VAR cFileName ;
      DATALINK {||oFileName:SetData(), ;
                  _ValidFile(cFileName), ;
                  DC_GetRefresh(GetList)} ;
      SIZE 50,8 ;
      EXT '*.TXT','*.*'

   @ 15,2 DCCHECKBOX lPreview PROMPT 'Preview on Screen'
   @ 16,2 DCCHECKBOX lStripEscape PROMPT 'Strip out Escape Sequences'

   DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk

ENDIF

IF lOK
   nHandle := DC_TxtOpen(cFileName)
   IF nHandle <= 0
     RETURN .f.
   ENDIF
   IF Empty(cFont) .AND. Valtype(aOptions) = 'A' .AND. !Empty(aOptions[11])
     cFont := aOptions[11]
   ENDIF

   cText := DC_TxtLine(nHandle)
   IF Chr(16) + 'PAGESIZE:' $ cText
      cText := Strtran(cText,Chr(16),'')
      cText := Strtran(cText,Chr(17),'')
      aTokens := DC_TokenArray(Strtran(cText,'PAGESIZE:',''),',')
      ASize(aTokens,2)
      DEFAULT aTokens[1] := '60'
      DEFAULT aTokens[2] := '132'
      nPageRows := Val(aTokens[1])
      nPageCols := Val(aTokens[2])
      DC_TxtSkip(nHandle,1)
   ELSE
      nPageRows := 62
      nPageCols := 132
   ENDIF
   lGui := DC_Gui(.t.)
   DEFAULT lPreview := .f.
   IF lPreview
      IF Valtype(aOptions) = 'A'
        ASize(aOptions,DCPRINT_OPTIONARRAY_SIZE)
        nZoomFactor := aOptions[21]
      ENDIF
      DEFAULT nZoomFactor := 1.5
      DEFAULT cFont := '11.Courier New'
      DCPRINT ON FONT cFont TO oPrinter PREVIEW ;
         OPTIONS aOptions ;
         ZOOMFACTOR nZoomFactor ;
         NOSTOP  ;
         ;// HIDE ;
         ENABLECANCEL
   ELSE
      DEFAULT cFont := '11.Courier New Bold'
      DCPRINT ON ;
         FONT cFont ;
         TO oPrinter ;
         SIZE nPageRows, nPageCols ;
         FONTBUTTON ;
         OPTIONS aOptions ;
         ENABLECANCEL
   ENDIF

   IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
      DC_Gui(lGui)
      DC_TxtClose(nHandle)
      RETURN .f.
   ENDIF
   lFixed := .f.

   DO WHILE !DC_TxtEof(nHandle) .AND. DC_PrinterOk(oPrinter)

      cText := DC_TxtLine(nHandle)

      DC_TxtSkip(nHandle,1)
      IF Chr(16) $ cText
         cText := Strtran(cText,Chr(16),'')
         cText := Strtran(cText,Chr(17),'')
         IF cText = 'FONT:'
            DCPRINT FONT Strtran(cText,'FONT:','') PRINTER oPrinter
         ELSEIF cText = 'EJECT'
            DCPRINT EJECT PRINTER oPrinter
         ELSEIF cText = 'FIXED'
            lFixed := Strtran(cText,'FIXED:','') == 'ON'
         ENDIF
         LOOP
      ENDIF
      lEject := .f.
      lEjectAfterPrint := .f.
      IF Chr(12) $ cText
        IF Right(cText,1) == Chr(12)
          lEjectAfterPrint := .t.
        ENDIF
        cText := Strtran(cText,Chr(12),'')
        lEject := .t.
      ENDIF
      IF Chr(10) $ cText
        cText := Strtran(cText,Chr(10),'')
      ENDIF
      IF Chr(13) $ cText
        cText := Strtran(cText,Chr(13),'')
      ENDIF
      IF lStripEscape .AND. Chr(27) $ cText
        LOOP
      ENDIF

      IF lEject
        IF lEjectAfterPrint
          IF lFixed
            @ DC_PrinterRow(oPrinter)+1,0 DCPRINT SAY cText FIXED PRINTER oPrinter
          ELSE
            @ DC_PrinterRow(oPrinter)+1,0 DCPRINT SAY Strtran(cText,' ',Chr(255)) ;
              PRINTER oPrinter
          ENDIF
        ENDIF
        IF DC_TxtEof(nHandle)
          EXIT
        ENDIF
        DCPRINT EJECT PRINTER oPrinter
        @ DC_PrinterRow(oPrinter)+1,0 DCPRINT SAY ''
      ELSEIF DC_PrinterRow(oPrinter) >= nPageRows
        DCPRINT EJECT PRINTER oPrinter
      ENDIF

      IF !lEjectAfterPrint
        IF lFixed
          @ DC_PrinterRow(oPrinter)+1,0 DCPRINT SAY cText FIXED PRINTER oPrinter
        ELSE
          @ DC_PrinterRow(oPrinter)+1,0 DCPRINT SAY Strtran(cText,' ',Chr(255)) ;
           PRINTER oPrinter
        ENDIF
      ENDIF

   ENDDO

   DC_TxtClose(nHandle)
   DC_Gui(lGui)

   DCPRINT OFF PRINTER oPrinter

ENDIF

RETURN .t.

* -----------------

STATIC FUNCTION _ValidFile( cFileName )

IF !Empty(cFileName) .AND. !File(cFileName)
   DC_MsgBox('File not Found!')
   RETURN .f.
ENDIF
RETURN .t.

* ------------------

FUNCTION DC_PrintBrowse( oBrowse, aOptions, xRef, lLines, nFudge, cTitle, ;
                         bEval, oPrinter, nRow, nFooterOption )
LOCAL nSaveRec, aHeaders, aColumns, aFooters, nSaveArea, ;
      i, nCol, oColumn, nRecord, nPreviousRecord, nColSize, ;
      xValue, oFont, cFont, nPointSize, nEvent, oXbp, mp1, mp2, ;
      nSeconds, lPrintOff := .t.

DEFAULT lLines := .t., ;
        nFudge := 4, ;
        nRow := 1, ;
        nFooterOption := 1  // 1 = footer on each page,  2 = footer on last page

aHeaders := Array(oBrowse:colCount)
aFooters := Array(oBrowse:colCount)
aColumns := Array(oBrowse:colCount)

IF Valtype(xRef) = 'U' .AND. Valtype(oBrowse:cargo) = 'A' .AND. ;
   Len(oBrowse:cargo) >= 25
  xRef := oBrowse:cargo[5]
ENDIF

IF Valtype(xRef) = 'C'
  nSaveArea := Select()
  dbSelectArea(xRef)
  nSaveRec := RecNo()
  DC_DbGoTop()
ENDIF

FOR i := 1 TO Len(aColumns)
  oColumn := oBrowse:getColumn(i)
  IF !Empty(oColumn:heading:cargo)
    aHeaders[i] := oColumn:heading:cargo
  ELSE
    aHeaders[i] := Strtran(oColumn:heading:referenceString,';',' ')
  ENDIF
  aColumns[i]   := oColumn
  IF !Empty(oColumn:footing:cargo)
    aFooters[i] := oColumn:footing:cargo
  ELSEIF 'BRUMSEL' $ Upper(oColumn:footing:referenceString)
    aFooters[i] := ''
  ELSE
    aFooters[i] := Strtran(oColumn:footing:referenceString,';',' ')
  ENDIF
  IF Valtype(aFooters[i]) = 'B'
    aFooters[i] := Eval(aFooters[i])
  ENDIF
NEXT

IF Empty(oPrinter)
  DCPRINT ON TO oPrinter OPTIONS aOptions PIXEL
  IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
    RETURN nil
  ENDIF
ELSE
  lPrintOff := .f.
  oPrinter:lPixel := .T.
ENDIF

oBrowse:goTop()

IF Valtype(oBrowse:dataSource) = 'C'
  nPreviousRecord := (oBrowse:dataSource)->(RecNo())
  oBrowse:stableblock := {||nRecord := (oBrowse:dataSource)->(RecNo())}
ELSEIF Valtype(oBrowse:dataSource) = 'N' // ADS SQL cursor
  nPreviousRecord := 0
  AdsGetRecordNum(oBrowse:dataSource,ADS_IGNOREFILTERS,@nPreviousRecord)
  oBrowse:stableblock := {||nRecord:=0,AdsGetRecordNum(oBrowse:dataSource,ADS_IGNOREFILTERS,@nRecord),nRecord}
ELSE
  nPreviousRecord := oBrowse:arrayElement
  oBrowse:stableblock := {||nRecord := oBrowse:arrayElement}
ENDIF

DO WHILE DC_PrinterOk(oPrinter) .AND. (Empty(bEval) .OR. Eval(bEval,oPrinter))

  nSeconds := Seconds()
  nEvent := -1
  DO WHILE nEvent # 0 .AND. Seconds() - nSeconds < 2
    nEvent := AppEvent( @mp1, @mp2, @oXbp, .1 )
    IF nEvent > 0 .AND. Valtype(oXbp) == 'O' .AND. !(nEvent = xbeM_Motion .AND. mp1 == NIL)
      oXbp:handleEvent( nEvent, mp1, mp2 )
    ENDIF
    IF nEvent = xbeP_Keyboard .AND. mp1 == xbeK_ESC
      oPrinter:lTerminated := .T.
    ENDIF
  ENDDO

  nCol := 10*nFudge
  IF nRow <= 1
    IF !Empty(cTitle)
      @ nRow+oPrinter:nRowSize,(oPrinter:nCols*oPrinter:nColSize)/2 DCPRINT SAY cTitle ;
        FONT '12.Arial Bold' ;
        ALIGN DCPRINT_ALIGN_HCENTER ;
        PRINTER oPrinter

      nRow += (oPrinter:nRowSize)
    ENDIF
    nRow += oPrinter:nRowSize
    IF lLines
      @ nRow,nCol,(oPrinter:nRows-1)*oPrinter:nRowSize,oPrinter:nCols*oPrinter:nColSize ;
        DCPRINT BOX PRINTER oPrinter
      @ nRow+oPrinter:nRowSize,nCol,nRow+oPrinter:nRowSize,oPrinter:nCols*oPrinter:nColSize ;
           DCPRINT LINE PRINTER oPrinter
      @ nRow+oPrinter:nRowSize+5,nCol,nRow+oPrinter:nRowSize+5,oPrinter:nCols*oPrinter:nColSize ;
           DCPRINT LINE PRINTER oPrinter
    ENDIF

    FOR i := 1 TO Len(aColumns)
      nColSize := aColumns[i]:currentSize()[1]*nFudge
      IF nCol + nColSize > oPrinter:nCols*oPrinter:nColSize
        EXIT
      ENDIF
      IF lLines
        @ nRow,nCol,(oPrinter:nRows-1)*oPrinter:nRowSize,nCol DCPRINT LINE PRINTER oPrinter
      ENDIF
      oFont := aColumns[i]:heading:setFont()
      IF !Empty(oFont)
        cFont := oFont:compoundName
        nPointSize := oFont:nominalPointSize
        cFont := Alltrim(Str(nPointSize)) + '.' + cFont
      ELSE
        cFont := aColumns[i]:heading:setFontCompoundName()
      ENDIF
      IF Empty(cFont)
        cFont := oBrowse:setFontCompoundName()
      ENDIF
      @ nRow+oPrinter:nRowSize-10,nCol+10 DCPRINT SAY aHeaders[i] ;
                  PRINTER oPrinter ;
                  FONT cFont ;
                  WIDTH nColSize
      nCol += nColSize
    NEXT
    IF lLines
      @ nRow,nCol,(oPrinter:nRows-1)*oPrinter:nRowSize,nCol DCPRINT LINE PRINTER oPrinter
    ENDIF
    nRow += (oPrinter:nRowSize*2)
  ENDIF
  nCol := 10*nFudge
  IF lLines
    @ nRow,nCol,nRow,oPrinter:nCols*oPrinter:nColSize DCPRINT LINE PRINTER oPrinter
  ENDIF
  FOR i := 1 TO Len(aColumns)
    nColSize := aColumns[i]:currentSize()[1]*nFudge
    IF nCol + nColSize > oPrinter:nCols*oPrinter:nColSize
      EXIT
    ENDIF
    xValue := Eval(aColumns[i]:dataLink)
    IF !Empty(xValue)
      oFont := aColumns[i]:dataArea:setFont()
      IF !Empty(oFont)
        cFont := oFont:compoundName
        nPointSize := oFont:nominalPointSize
        cFont := Alltrim(Str(nPointSize)) + '.' + cFont
      ELSE
        cFont := aColumns[i]:heading:setFontCompoundName()
      ENDIF
      IF Empty(cFont)
        cFont := oBrowse:setFontCompoundName()
      ENDIF
      @ nRow-10,nCol+10 DCPRINT SAY xValue ; // Eval(aColumns[i]:dataLink) ;
                PRINTER oPrinter ;
                FONT cFont ;
                WIDTH nColSize
    ENDIF
    nCol += nColSize
  NEXT
  nRow += (oPrinter:nRowSize)

  IF (nRow > oPrinter:nRows*oPrinter:nRowSize) .OR. ;
     (nFooterOption = 1 .AND. nRow > (oPrinter:nRows-1)*oPrinter:nRowSize)
    IF nFooterOption = 1
      nRow -= (oPrinter:nRowSize)
      nCol := 10*nFudge
      FOR i := 1 TO Len(aColumns)
        nColSize := aColumns[i]:currentSize()[1]*nFudge
        IF nCol + nColSize > oPrinter:nCols*oPrinter:nColSize
          EXIT
        ENDIF
        IF lLines
          @ nRow+5,nCol, ;
            nRow+5,oPrinter:nCols*oPrinter:nColSize ;
              DCPRINT LINE PRINTER oPrinter
        ENDIF
        oFont := aColumns[i]:footing:setFont()
        IF !Empty(oFont)
          cFont := oFont:compoundName
          nPointSize := oFont:nominalPointSize
          cFont := Alltrim(Str(nPointSize)) + '.' + cFont
        ELSE
          cFont := aColumns[i]:footing:setFontCompoundName()
        ENDIF
        IF Empty(cFont)
          cFont := oBrowse:setFontCompoundName()
        ENDIF
        @ nRow+oPrinter:nRowSize-10,nCol+10 DCPRINT SAY aFooters[i] ;
                    PRINTER oPrinter ;
                    FONT cFont ;
                    WIDTH nColSize
        nCol += nColSize
      NEXT
    ENDIF
    DCPRINT EJECT PRINTER oPrinter
    nRow := 1
  ENDIF
  oBrowse:down()
  oBrowse:forcestable()
  IF nRecord == nPreviousrecord
    EXIT
  ENDIF
  nPreviousrecord := nRecord
ENDDO

IF nFooterOption > 0
  nCol := 10*nFudge
  nRow := (oPrinter:nRowSize*oPrinter:nRows) - (oPrinter:nRowSize*2)
  IF lLines
     @ nRow,nCol, ;
       nRow,oPrinter:nCols*oPrinter:nColSize ;
       DCPRINT LINE PRINTER oPrinter
     @ nRow-5,nCol, ;
       nRow-5,oPrinter:nCols*oPrinter:nColSize ;
           DCPRINT LINE PRINTER oPrinter
  ENDIF
  FOR i := 1 TO Len(aColumns)
    nColSize := aColumns[i]:currentSize()[1]*nFudge
    IF nCol + nColSize > oPrinter:nCols*oPrinter:nColSize
      EXIT
    ENDIF
    oFont := aColumns[i]:footing:setFont()
    IF !Empty(oFont)
      cFont := oFont:compoundName
      nPointSize := oFont:nominalPointSize
      cFont := Alltrim(Str(nPointSize)) + '.' + cFont
    ELSE
      cFont := aColumns[i]:footing:setFontCompoundName()
    ENDIF
    IF Empty(cFont)
      cFont := oBrowse:setFontCompoundName()
    ENDIF
    @ nRow+oPrinter:nRowSize-10,nCol+10 DCPRINT SAY aFooters[i] ;
                PRINTER oPrinter ;
                FONT cFont ;
                WIDTH nColSize
    nCol += nColSize
  NEXT
ENDIF

IF lPrintOff
  DCPRINT OFF PRINTER oPrinter
ELSE
  oPrinter:lPixel := .F.
ENDIF

RETURN nil

* -------------

STATIC CLASS XbpPreview FROM XbpStatic

   PROTECTED:
   VAR oFont                      // XbpFont
   VAR aViewPort                  // View port for zoom
   VAR aPageSize                  // Printer page size
   VAR aCharAttr                  // Attributes for strings (GRA_AS_BOX)
   VAR aAreaAttr                  // Attributes for areas   (GRA_AA_COLOR)
   VAR nPagePos                   // Current page position
   VAR nRows                      // Number of rows per page
   VAR nUnits                     // Units

   METHOD calcScrollBox           // Calculate size of scroll box inside scroll bars

   EXPORTED:
   VAR hScroll    READONLY        // Horizontal scroll bar
   VAR vScroll    READONLY        // Vertical   scroll bar
   VAR lScroll
   VAR oPagePos                   // Spinbutton for displaying current page position
   VAR oPages                     // Static for displaying number of pages
   VAR drawBlock                  // Code block calls function that draws
   VAR zoomFactor                 // Zoom factor from 0 to n
   VAR zoomIncr                   // Zoom increment
   VAR segments                   // Array containing segment IDs

   VAR oPresSpace                 // XbpPresSpace
   VAR oView                      // XbpDialog used as display area
   VAR oSquare                    // XbpStatic to fill the gap between scroll bars
   VAR oPrinter                   // DC_Printer() object
   VAR printer                    // XbpPrinter() object
   VAR nTimeOut                   // Display timeout
   VAR isScrollBars               // Display scrollbars

                                  ** Life cycle
   METHOD init                    //
   METHOD create                  //
   METHOD destroy                 //
                                  ** Display
   METHOD setSize                 // Define size
   METHOD hScroll                 // Scroll horizontally
   METHOD vScroll                 // Scroll vertically
   METHOD zoom                    // Zoom
   METHOD setViewPort             // Define size of view port
                                  ** Printing
   METHOD numPages                // Determine number of pages

   METHOD setup
   METHOD gotoPage
   METHOD setOrigin               // Set origin for the view port

ENDCLASS

* -------------

METHOD XbpPreview:init( oParent, oOwner, aPos, aSize, aPP, lVisible, ;
                        aPageSize, nUnits, lScrollBars )

   ::XbpStatic:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpStatic:type  := XBPSTATIC_TYPE_TEXT
   ::XbpStatic:tabStop := .t.

   ::oView           := XbpDialog():new( self )
   ::oView:tabStop := .t.

   ::isScrollBars := lScrollBars
   DEFAULT ::isScrollBars TO .t.

   IF ::isScrollBars
     ::vScroll         := XbpScrollbar():new( self )
     ::vScroll:type    := XBPSCROLL_VERTICAL
     ::vScroll:cargo   := 0
     ::vScroll:autoTrack := .f.
   ENDIF

   ::oPagePos        := XbpSpinButton():new( self )
   ::oPagePos:tabStop := .t.
   ::oPagePos:dataLink := {|x|IIF(x==nil,::oPrinter:nCurrPage,::oPrinter:nCurrPage:=x)}
   ::oPagePos:keyboard := {|a,b,o|IIF(a==xbeK_ENTER,o:getData(),nil), ;
                                  IIF(a==xbeK_ENTER,::oPrinter:paint(),nil)}
   ::oPagePos:killInputFocus := {|a,b,o|o:getData(),::oPrinter:paint()}
   ::oPagePos:endSpin := {|a,b,o|o:getData(),::oPrinter:paint()}

   ::oPages := XbpStatic():new( self )
   ::oPages:type := XBPSTATIC_TYPE_TEXT
   ::oPages:options := XBPALIGN_BOTTOM

   IF lScrollBars
     ::hScroll         := XbpScrollbar():new( self )
     ::hScroll:type    := XBPSCROLL_HORIZONTAL
     ::hScroll:cargo   := 0
     ::hScroll:autoTrack := .f.
   ENDIF

   ::oSquare         := XbpStatic():new( self )
   ::oSquare:type    := XBPSTATIC_TYPE_RECESSEDBOX

   ::oPresSpace      := XbpPresSpace():new()

   ::zoomFactor      := 1
   ::segments        := {}
   ::nPagePos        := 1
   ::nRows           := 0
   ::nUnits          := nUnits
   ::lScroll         := .f.
   ::nTimeout        := 0

RETURN self

* ------------

METHOD XbpPreview:create( oParent, oOwner, aPos, aSize, aPP, lVisible, oPrinter, ;
                          nUnits )

   LOCAL oFont, i, imax, aFontList

   // XbpStatic is parent for all other XBPs
   ::xbpStatic:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   // XbpDialog is displayed without title bar
   ::oView:minButton := .F.
   ::oView:maxButton := .F.
   ::oView:sysMenu   := .F.
   ::oView:titleBar  := .F.
   ::oView:border    := XBPDLG_THINBORDER

   ::oView:drawingArea:lbdown := {|| ::zoom( ::zoomFactor + ::zoomIncr ) }
   ::oView:drawingArea:rbdown := {|| ::zoom( ::zoomFactor - ::zoomIncr ) }

   ::oView:create()

   ::oPagePos:create()
   ::oPagePos:setFontCompoundName( "8.Courier Bold" )

   ::oPages:create()
   ::oPages:setFontCompoundName( "8.Courier Bold" )

   // Create scroll bars and XbpStatic to fill the gap
   ::oSquare:create()

   IF ::isScrollBars
     ::hScroll:create()
     ::vScroll:create()
     ::hScroll:scroll := {|mp1| ::hScroll( mp1 ) }
     ::vScroll:scroll := {|mp1| ::vScroll( mp1 ) }
   ENDIF

   // Size of XBPs is calculated in the :setSize() method
   ::setSize( ::currentSize() )

   ::setup()

RETURN self

* ------------

METHOD XbpPreview:setup()

LOCAL aSize

   ::aPageSize := { Int(::oView:currentSize()[1]*5), ;
                    Int(::oView:currentSize()[2]*5) }

   ::oPresSpace:configure( ::oView:drawingArea:winDevice(), ;
                           ::aPageSize, GRA_PU_LOMETRIC )

   // Erase drawing using a filled white box on repaint
   ::aCharAttr := Array( GRA_AS_COUNT )
   ::aAreaAttr := Array( GRA_AA_COUNT )
   ::aAreaAttr [ GRA_AA_COLOR ] := GRA_CLR_BLACK
   ::oPresSpace:setAttrArea( ::aAreaAttr )

   // Initialize view port
   aSize       := ::oView:drawingArea:currentSize()

   ::aViewPort := { 0, 0, aSize[1], aSize[2] }
   ::oView:drawingArea:paint := {||::oPrinter:paint() }


   ::zoom(nil,.f.)

RETURN self

* -------------

METHOD XbpPreview:destroy

   ::xbpStatic:destroy()
   ::aViewPort := ;
   ::aPageSize := ;
   ::oFont     := NIL

RETURN self

* -------------

METHOD XbpPreview:setSize( aSize )

   ::xbpStatic:setSize( aSize )
   aSize := ::currentSize()

   ::oPagePos:setPos ( { 0, 0 } )
   ::oPagePos:setSize( { 60, 16 } )

   ::oPages:setPos ( { 62, 0 } )
   ::oPages:setSize( { 98, 16 } )

   IF ::isScrollBars
     ::hScroll:setPos ( {160, 0 } )
     ::hScroll:setSize( { aSize[1]-16-160, 16 } )
     ::vScroll:setPos ( { aSize[1]-16, 16 } )
     ::vScroll:setSize( { 16, aSize[2]-16 } )
   ENDIF

   ::oSquare:setPos ( { aSize[1]-16,  0 } )
   ::oSquare:setSize( { 16, 16 } )
   ::oView:setPos ( { 0 , 16 } )
   ::oView:setSize( { aSize[1]-16, aSize[2]-16 } )

RETURN self

* -------------

METHOD XbpPreview:hScroll( mp1 )
   LOCAL nScrollPos := mp1[1]
   LOCAL nCommand   := mp1[2]
   LOCAL nScroll

   IF (nScrollPos == 0                               .AND. ;
       ::hScroll:getData() == 0)                     .OR.  ;
      (nScrollPos == ::hScroll:setRange()[2]         .AND. ;
       ::hScroll:getData() == ::hScroll:setRange()[2] )
       RETURN self
   ENDIF

   DO CASE
   CASE nCommand == XBPSB_PREVPOS
      nScroll = ::hScroll:getData() - ::hScroll:setScrollBoxSize()
      ::hScroll:setData( Max(nScroll, 0) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPOS
      nScroll = ::hScroll:getData() + ::hScroll:setScrollBoxSize()
      ::hScroll:setData( Min(nScroll, ::hScroll:setRange()[2]) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_PREVPAGE
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPAGE
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_ENDTRACK
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   ENDCASE

RETURN self

* ------------

METHOD XbpPreview:vScroll( mp1 )
   LOCAL nScrollPos := mp1[1]
   LOCAL nCommand   := mp1[2]
   LOCAL nScroll

   IF (nScrollPos == 0                               .AND. ;
       ::vScroll:getData() == 0)                     .OR.  ;
      (nScrollPos == ::vScroll:setRange()[2]         .AND. ;
       ::vScroll:getData() == ::vScroll:setRange()[2] )
       RETURN self
   ENDIF

   DO CASE
   CASE nCommand == XBPSB_PREVPOS
      nScroll = ::vScroll:getData() - ::vScroll:setScrollBoxSize()
      ::vScroll:setData( Max(nScroll, 0) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPOS
      nScroll = ::vScroll:getData() + ::vScroll:setScrollBoxSize()
      ::vScroll:setData( Min(nScroll, ::vScroll:setRange()[2]) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_PREVPAGE
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPAGE
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_ENDTRACK
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   ENDCASE

RETURN self

* -------------

METHOD XbpPreview:setOrigin( nX, nY, lPaint, lZero )

   LOCAL aSize       := ::oView:currentSize()
   LOCAL nViewWidth  := aSize[1]
   LOCAL nViewHeight := aSize[2]
   LOCAL nZoomWidth  := nViewWidth  * ::zoomFactor // * ( .9 )
   LOCAL nZoomHeight := nViewHeight * ::zoomFactor

   DEFAULT lPaint := .t., ;
           lZero := .f.

   // X origin is always <= 0
   nX := - Abs( nX )

   IF nZoomWidth <= nViewWidth
      nX := 0
   ELSEIF nViewWidth - nX >= nZoomWidth
      nX := nViewWidth - nZoomWidth
   ENDIF

   ::aViewPort[1] := nX
   ::aViewPort[3] := nX + nZoomWidth

   // Y origin is always <= 0
   // Consider the difference between visible and total height
   nY := Abs( nY ) - ( nZoomHeight - nViewHeight )

   IF nY > 0 .OR. nZoomHeight <= nViewHeight
      nY := 0
   ELSEIF nViewHeight - nY >= nZoomHeight
      nY := nViewHeight - nZoomHeight
   ENDIF

   ::aViewPort[2] := nY
   ::aViewPort[4] := nY + nZoomHeight

   IF ::isScrollBars
     ::lScroll := ::vScroll:getData() >= Int(nZoomHeight-nViewHeight)
   ELSE
     ::lScroll := .f.
   ENDIF

   ::setViewPort( ::aViewPort )
   IF Valtype(::oPrinter) = 'O'
     IF lZero .AND. ::isScrollBars
       ::hScroll:setData(0)
       ::vScroll:setData(0)
     ENDIF
     IF lPaint
       ::oPrinter:paint()
     ENDIF
   ENDIF

RETURN self

* --------------

METHOD XbpPreview:calcScrollBox()
   // LOCAL aSize       := ::oView:drawingArea:currentSize()
   LOCAL aSize       := ::oView:currentSize()
   LOCAL nViewWidth  := aSize[1]
   LOCAL nViewHeight := aSize[2]
   LOCAL nZoomWidth  := aSize[1] * ::zoomFactor
   LOCAL nZoomHeight := aSize[2] * ::zoomFactor

   IF !::isScrollBars
     RETURN self
   ENDIF

   // Calculation for horizontal scroll bar
   ::hScroll:setRange( { 0, Int(nZoomWidth - nViewWidth) } )
   IF nZoomWidth > nViewWidth
      ::hScroll:setScrollBoxSize( (nZoomWidth-nViewWidth) * (nViewWidth/nZoomWidth) )
   ELSE
      ::hScroll:setScrollBoxSize( nViewWidth )
   ENDIF

   // Calculation for vertical scroll bar
   ::vScroll:setRange( { 0, Int(nZoomHeight - nViewHeight) } )

   IF nZoomHeight > nViewHeight
      ::vScroll:setScrollBoxSize( (nZoomHeight-nViewHeight) * (nViewHeight/nZoomHeight) )
      IF !::oPrinter:lTranslate .AND. ::lScroll
        PostAppEvent(xbeSB_Scroll,{nZoomHeight-nViewHeight,XBPSB_NEXTPAGE},,::vScroll)
      ENDIF
   ELSE
      ::vScroll:setScrollBoxSize( nViewHeight )
   ENDIF

RETURN self

* ------------

METHOD XbpPreview:zoom( nZoomFactor, lPaint )

   //LOCAL aSize  := ::oView:drawingArea:currentSize()
   LOCAL aSize  := ::oView:currentSize()

   DEFAULT nZoomFactor TO ::zoomFactor
   DEFAULT lPaint TO .t.

   ::zoomFactor := Max( 0, nZoomFactor )

   _ClearScreen( ::oPresSpace )

   // Re-calculate view port
   aSize[1] := Int( aSize[1] * nZoomFactor )
   aSize[2] := Int( aSize[2] * nZoomFactor )

   ::aViewPort  := {0,0,aSize[1],aSize[2]}
   ::calcScrollBox()

   IF ::isScrollBars
     // Set origin for view port
     ::setOrigin( ::hScroll:getData(), ::vScroll:getData(), lPaint )
   ELSE
     ::setOrigin( 0, 0, lPaint )
   ENDIF

RETURN self

* ------------

METHOD XbpPreview:setViewPort( aViewPort )
   LOCAL aOldViewPort := ::oPresSpace:setViewPort()

   IF Valtype( aViewPort ) == "A"
      ::aViewPort := aViewPort
      ::oPresSpace:setViewPort( aViewPort )
   ENDIF
RETURN aOldViewPort

* --------------

METHOD XbpPreview:numPages()
   LOCAL nPages

   IF ::nRows == 0
      nPages := 1
   ELSE
      nPages := Int( RecCount() / ::nRows ) + ;
                IIF( RecCount() % ::nRows != 0, 1, 0 )
   ENDIF
RETURN nPages

* --------------

METHOD XbpPreview:gotoPage()

LOCAL GetList := {}, lOk

@ 0,0 DCSAY DC_LangMsg(DCMSG_PC_PAGE) + ;
      ' (1-' + Alltrim(Str(Len(::oPrinter:aBuffer))) + ')';
      GET ::oPrinter:nCurrPage RANGE 1,Len(::oPrinter:aBuffer) SAYSIZE 0 ;
      PICT '9999'

DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk ENTEREXIT

::oPrinter:paint()

RETURN self

* ----------------

STATIC FUNCTION _ClearScreen( oPS, nColorBG )


// Erase drawing using a filled white box on repaint
LOCAL aAreaAttr := Array( GRA_AA_COUNT ), aSaveAttr := oPS:setAttrArea()

DEFAULT nColorBG := GRA_CLR_WHITE

aAreaAttr[ GRA_AA_COLOR ] := nColorBG
oPS:setAttrArea( aAreaAttr )

GraBox( oPS, {0,0}, {9000,9000}, GRA_FILL )

oPS:setAttrArea( aSaveAttr )

RETURN nil

* ----------------

FUNCTION DC_PrintClipBoard( lPreview )

LOCAL oBitMap, aFormats, oClipBoard, oPrinter

DEFAULT lPreview := .f.

oClipboard := XbpClipboard():new():create()
oClipBoard:open()
aFormats := oClipBoard:queryFormats()
IF AScan( aFormats, XBPCLPBRD_BITMAP ) > 0
  oBitmap := oClipBoard:getBuffer( XBPCLPBRD_BITMAP )
  oClipboard:clear()
  oClipboard:close()
ELSE
  oClipboard:destroy()
  RETURN .f.
ENDIF

oClipBoard:destroy()

IF lPreview
  DCPRINT ON PREVIEW TO oPrinter ZOOMFACTOR 2.5
ELSE
  DCPRINT ON TO oPrinter
ENDIF

IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
  RETURN .f.
ENDIF

@ 0,1 DCPRINT BITMAP oBitMap PRINTER oPrinter SCALE 2

DCPRINT OFF PRINTER oPrinter

RETURN .t.


* ------------------

// contributed by Michael Rudrich

FUNCTION DC_CalcPrinterColForRightJustified(oPrinter,xValue,nRow,cPictureString)

LOCAL aNecessaryRoomSpace   := {}
LOCAL nNecessarySpaceInPixels := 0
LOCAL nNumberOfColumnsToSubstract := 0
LOCAL nStartingPosition := 0
LOCAL cGraStringToPrint := ""

// Some necessary defaults
DEFAULT oPrinter := DC_PrinterObject()
DEFAULT cPictureString  := ""

IF valtype(xValue) = "N"
   cGraStringToPrint   := transform(xValue,cPictureString)                                            // Make a string out of the numeric
 ELSEIF valtype(xValue) = "D"
   cGraStringToPrint   := dtoc(xValue)                                                                // Change date to string
 ELSEIF valtype(xValue) = "C"
   cGraStringToPrint   := xValue
ENDIF

aNecessaryRoomSpace := GraQueryTextBox(oPrinter:oPs,cGraStringToPrint)                             // Calculate the necessary space we need

nNecessarySpaceInPixels     := aNecessaryRoomSpace[3,1] - aNecessaryRoomSpace[2,1]                 // Calculate number of Pixels
nNumberOfColumnsToSubstract := nNecessarySpaceInPixels  /  (oPrinter:aPageSize[1]/oPrinter:nCols)  // Calculate the Columns needed

return (nRow - nNumberOfColumnsToSubstract)

* ------------

FUNCTION DC_PrintPreviewAcrobatOpt( aOptions )

STATIC saOptions := { 0, nil, '5', nil, nil, .f., 'Win2PDF', 3, nil, .F., .F. }

LOCAL aOldoptions := saOptions, i

IF Valtype(aOptions) = 'A'
  ASize(aOptions,Len(saOptions))
  FOR i := 1 TO Len(aOptions)
    DEFAULT aOptions[i] := saOptions[i]
  NEXT
  saOptions := aOptions
ENDIF

RETURN aOldOptions

* ------------

FUNCTION DC_PrintPreviewXPSWriterOpt( aOptions )

STATIC saOptions := { 'Microsoft XPS Document Writer', nil, .f., .t. }

LOCAL aOldoptions := saOptions, i

IF Valtype(aOptions) = 'A'
  ASize(aOptions,Len(saOptions))
  FOR i := 1 TO Len(aOptions)
    DEFAULT aOptions[i] := saOptions[i]
  NEXT
  saOptions := aOptions
ENDIF

RETURN aOldOptions

* ------------

FUNCTION DC_PrintPreviewImageWriterOpt( aOptions )

STATIC saOptions := { 'Microsoft Office Document Image Writer', nil, .f., .t. }

LOCAL aOldoptions := saOptions, i

IF Valtype(aOptions) = 'A'
  ASize(aOptions,Len(saOptions))
  FOR i := 1 TO Len(aOptions)
    DEFAULT aOptions[i] := saOptions[i]
  NEXT
  saOptions := aOptions
ENDIF

RETURN aOldOptions

* ------------

FUNCTION DC_PrintPreviewAcrobat( cPDFName, cTitle, lOkCancel, lNoSpawn )

LOCAL oDlg, oAcrobat, GetList[0], GetOptions, lStatus, oAcrobatDlg, ;
      oWebBrowser, oToolBar, oStatusBar, cParams, nStatus, ;
      nSeconds, i, aDir, cPDFPath

LOCAL cJazzAgeKey, aOptions := DC_PrintPreviewAcrobatOpt()

DEFAULT cTitle := cPDFName, ;
        lNoSpawn := .f.

ASize(aOptions,11)
DEFAULT aOptions[1] := 1, ;              // 1 - Non-Modal, 2 - Modal
        aOptions[2] := AppDeskTop(), ;   // Parent
        aOptions[3] := '5', ;            // Acrobat version
        aOptions[6] := .t., ;            // Add Ok/Cancel buttons
        aOptions[7] := 'Win2PDF', ;      // PDF Printer Driver
        aOptions[8] := 3, ;              // 1 - Acrobat Control, 2 - Web Browser Control,  3 - RunShell
        aOptions[9] := '', ;             // Path for *.PDF files
        aOptions[10] := .F.,;            // Name PDF to cTitle
        aOptions[11] := .T.              // Erase Temp PDF Files

DEFAULT lOkCancel := aOptions[6]

IF aOptions[8] # 3 // ActiveX

  IF lOkCancel
    DCSTATUSBAR oStatusBar HEIGHT 24 ALIGN DCGUI_ALIGN_BOTTOM
    @ 1,1 DCTOOLBAR oToolBar SIZE 100,22 BUTTONSIZE 70,22 PIXEL PARENT oStatusBar
    DCADDBUTTON CAPTION DC_LangMsg(DCMSG_OK) ;
      PARENT oToolBar ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} PIXEL
    DCADDBUTTON CAPTION DC_LangMsg(DCMSG_CANCEL) ;
      PARENT oToolBar ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} PIXEL
  ENDIF

  DCGETOPTIONS ;
    AUTORESIZE ;
    PIXEL ;
    WINDOWHEIGHT 600 ;
    WINDOWWIDTH 600

  DCREAD GUI ;
    APPWINDOW aOptions[2] ;
    OPTIONS GetOptions ;
    TO lStatus ;
    TITLE cTitle ;
    PARENT @oDlg ;
    NODESTROY ;
    _MODAL aOptions[1] == 2 ;
    EVAL {|o|_AcrobatControl( oDlg, aOptions, cPDFName, lOkCancel, ;
                              @oAcrobat, @oWebBrowser )}

ELSE

  cPDFName := Strtran(cPDFName,'\\','\')
  cPDFPath := aOptions[9]
  IF Empty(cPDFPath)
    cPDFPath := DC_Path(cPDFName)
  ENDIF
  IF !(Right(cPDFPath,1) $ ':\')
    cPDFPath += '\'
  ENDIF

  IF aOptions[11] // Erase Temporary PDF files
    IF '.$$$.' $ cPDFName
      aDir := Directory(cPDFPath + '*.$$$.PDF')
    ELSE
      aDir := Directory(cPDFPath + '*_.PDF')
    ENDIF
    FOR i := 1 TO Len(aDir)
      IF !Alltrim(Upper(cPDFPath+aDir[i,1])) $ Alltrim(Upper(cPDFName))
        FErase(cPDFPath+aDir[i,1])
      ENDIF
    NEXT
  ENDIF

  IF !lNoSpawn .AND. (Trim(aOptions[7]) = 'Win2PDF' .OR. Trim(aOptions[7]) = 'Bullzip PDF Printer' .OR. ;
              AScan(XbpPrinter():new():list(), {|c|c=='Microsoft XPS Document Writer'}) == 0)

    nSeconds := Seconds()
    DO WHILE !FExists(cPDFName) .AND. Seconds() - nSeconds < 5
      Sleep(50)
    ENDDO
    lStatus := .F.
    DC_SpawnUrl(cPDFName)
  ENDIF

ENDIF

IF Valtype(aOptions[5]) == 'B'
  IF aOptions[8] == 1
    Eval(aOptions[5],oDlg,oAcrobat)
  ELSEIF aOptions[8] == 2
    Eval(aOptions[5],oDlg,oWebBrowser)
  ENDIF
ENDIF

#if XPPVER < 1900000

  IF aOptions[8] == 1
    oAcrobat:Disconnect()
  ELSEIF aOptions[8] == 2
    oWebBrowser:disConnect()
  ENDIF
#endif

Sleep(50)

IF Valtype(oDlg) = 'O'
  oDlg:destroy()
ENDIF

IF aOptions[8] # 3 .AND. '.$$$.PDF' $ cPDFName .AND. ( !lOkCancel .OR. !lStatus )
  nStatus := -1
  nSeconds := Seconds()
  DO WHILE nStatus == -1 .OR. Seconds() - nSeconds > 5 * 60
    nStatus := FErase(cPDFName)
    Sleep(100)
  ENDDO
ENDIF

RETURN lStatus

* ---------

STATIC FUNCTION _AcrobatControl( oDlg, aOptions, cPDFName, lOkCancel, ;
                                 oAcrobat, oWebBrowser )

IF aOptions[8] == 1

  oAcrobat := _CreateAcrobatControl( oDlg, aOptions, cPDFName, lOkCancel )

ELSEIF aOptions[8] == 2

  oWebBrowser := _CreateWebBrowser( oDlg, aOptions, cPDFName, lOkCancel )

ENDIF

RETURN nil

* ---------

STATIC FUNCTION _CreateAcrobatControl( oDlg, aOptions, cPDFName, lOkCancel )

LOCAL oAcrobat, nWidth, nHeight, nCol, nRow, cProgId, cJazzAgeKey, punk

IF aOptions[3] == '8'  // Acrobat version 8
  cProgId := "AcroPDF.PDF.1"
ELSEIF aOptions[3] == '7'  // Acrobat version 7
  cProgId := "AcroPDF.PDF.1"
ELSEIF aOptions[3] == '6'  // Acrobat version 6
  cProgId := "PDF.PdfCtrl.6"
ELSEIF aOptions[3] == '5'  // Acrobat version 5
  cProgId := "PDF.PdfCtrl.5"
ELSE                       // Acrobat version 4 and earlier
  cProgId := "PDF.PdfCtrl.1"
ENDIF

#if XPPVER > 1900000 // Xbase++ 1.9

  oAcrobat := XbpActiveXControl():new(oDlg:drawingArea)
  oAcrobat:CLSID  := cProgId
  oAcrobat:create(,,,oDlg:drawingArea:currentSize())

#else

  cProgId := "ProgID:" + cProgId

  nWidth  := oDlg:drawingArea:currentSize()[1] - IIF(lOkCancel,10,0)
  nHeight := oDlg:drawingArea:currentSize()[2]
  nCol    := oDlg:drawingArea:currentPos()[1]
  nRow    := oDlg:drawingArea:currentPos()[2]

  oAcrobat:= _Pdf():new()
  cJazzAgeKey := Alltrim(DC_JazzAgeKey())
  IF !(Left(cJazzAgeKey,1) == ';') .AND. !Empty(cJazzAgeKey)
    cJazzAgeKey := ';' + cJazzAgeKey
  ENDIF

  cProgID += cJazzAgeKey

  punk:=JAXPPCREATECONTROL(oDlg:drawingArea:getHWND(),"Acrobat1", nCol, nRow, nWidth, nHeight, cProgId,0)
  JAXPPSetControlResizeStyle(punk,JAHANDLE_PUNK,JARESIZESTYLE_X2RIGHT + JARESIZESTYLE_Y2BOTTOM)
  oAcrobat:Connect(punk)

  // Connect to the events fired by the ActiveX.
  oAcrobat:SubscribeToEvents({|hEvent| ReflectEventToStatusText(hEvent)})

#endif

oAcrobat:LoadFile(cPDFName)
oAcrobat:Print()

IF Valtype(aOptions[4]) == 'B'
  Eval(aOptions[4],oDlg,oAcrobat)
ENDIF

RETURN oAcrobat

* ------------

FUNCTION DC_PrintPreviewXPSWriter( cXPSName, cTitle, lNoSpawn )

LOCAL nSeconds, aDir, cXPSPath, i, lSpawn

LOCAL aOptions := DC_PrintPreviewXPSWriterOpt()

DEFAULT cTitle := cXPSName, ;
        lNoSpawn := .f.

cXPSName := Strtran(cXPSName,'\\','\')
cXPSPath := aOptions[2]
IF Empty(cXPSPath)
  cXPSPath := DC_Path(cXPSName)
ENDIF
IF !(Right(cXPSPath,1) $ ':\')
  cXPSPath += '\'
ENDIF

IF aOptions[3] // Erase Temporary XPS files
  IF '.$$$.' $ cXPSName
    aDir := Directory(cXPSPath + '*.$$$.XPS')
  ELSE
    aDir := Directory(cXPSPath + '*_.XPS')
  ENDIF
  FOR i := 1 TO Len(aDir)
    IF !Alltrim(Upper(cXPSPath+aDir[i,1])) $ Alltrim(Upper(cXPSName))
      FErase(cXPSPath+aDir[i,1])
    ENDIF
  NEXT
ENDIF

nSeconds := Seconds()
DO WHILE !FExists(cXPSName) .AND. Seconds() - nSeconds < 5
  Sleep(50)
ENDDO

lSpawn := aOptions[4]

IF !lNoSpawn .AND. lSpawn
  DC_SpawnUrl(cXPSName)
ENDIF

RETURN .t.

* ------------------

STATIC FUNCTION _CreateWebBrowser( oDlg, aOptions, cPDFName, lOkCancel )

LOCAL nWidth, nHeight, nCol, nRow, punk, cProgId, oWebBrowser, cCurPath

cCurPath := DC_CurPath()
IF Right(cCurpath,2) == ':\'
  cCurPath := SubStr(cCurPath,1,2)
ENDIF

cPDFName := cCurPath + '\' + cPDFName

#if XPPVER > 1900000

  oWebBrowser := XbpActiveXControl():new(oDlg:drawingArea)
  oWebBrowser:clsid := "Shell.Explorer.2"
  oWebBrowser:create(,,,oDlg:drawingArea:currentSize())

#else

  // Create an ActiveX instance in the Form client area, and wrap it in an Xbase++ class instance
  oWebBrowser:= WebBrowser():new()
  nWidth  := oDlg:drawingArea:currentSize()[1]
  nHeight := oDlg:drawingArea:currentSize()[2]
  nCol    := oDlg:drawingArea:currentPos()[1]
  nRow    := oDlg:drawingArea:currentPos()[2]

  cProgId := "ProgID:Shell.Explorer.2"
  punk := JAXPPCREATECONTROL(oDlg:drawingArea:getHWND(),;
           "WebBrowser",nCol,nRow,nWidth,nHeight,cProgId,1)

  JAXPPSETCONTROLRESIZESTYLE(punk,JAHANDLE_PUNK,JARESIZESTYLE_X2RIGHT + ;
         JARESIZESTYLE_Y2BOTTOM)

  oWebBrowser:Connect(punk)
  oWebBrowser:Navigate(cPDFName,0)

#endif

RETURN oWebBrowser

* -----------

#if XPPVER < 1900000

CLASS _Pdf

  HIDDEN:
    VAR m_pUnk

  EXPORTED:
    VAR ExceptionCodeBlock,m_EventsCookie,m_NotificationsCookie
    METHOD init,Connect,Disconnect,GetPUnk
    METHOD SubscribeToEvents,SubscribeToNotifications
    METHOD LoadFile, Print, PrintWithDialog

ENDCLASS

METHOD _Pdf:init()
  ::m_pUnk:=0
  ::m_EventsCookie:=0
  ::m_NotificationsCookie:=0
  ::ExceptionCodeBlock:=NIL
RETURN self

METHOD _Pdf:Connect(pObject)
  ::Disconnect()
  ::m_pUnk:=pObject
RETURN self

METHOD _Pdf:Disconnect()
  ::SubscribeToEvents(NIL)
  ::SubscribeToNotifications(NIL)
  JAXPPDELETECONTROL(::m_pUnk)
RETURN self

METHOD _Pdf:GetPUnk()
RETURN ::m_pUnk

METHOD _Pdf:Print()
  JAXPPCALLACTIVEXMETHOD(::m_pUnk,14,1,0,@::ExceptionCodeBlock)
RETURN self

METHOD _Pdf:printWithDialog()
  JAXPPCALLACTIVEXMETHOD(::m_pUnk,15,1,0,@::ExceptionCodeBlock)
RETURN self

METHOD _Pdf:LoadFile(_fileName)
LOCAL vret
  vret=JAXPPCALLACTIVEXMETHOD(::m_pUnk,2,1,11,@::ExceptionCodeBlock,_fileName,8,6)
RETURN(vret)

METHOD _Pdf:SubscribeToEvents(hEventsControlBlock)
  JAXPPUNSUBSCRIBETOOCXEVENTS(@::m_EventsCookie)
  ::m_EventsCookie:=JAXPPSUBSCRIBETOOCXEVENTS(::m_pUnk,'',@hEventsControlBlock)
RETURN self

METHOD _Pdf:SubscribeToNotifications(hNotificationsControlBlock)
  JAXPPUNSUBSCRIBETOOCXEVENTS(@::m_NotificationsCookie)
  ::m_NotificationsCookie:=JAXPPSUBSCRIBETOOCXNOTIFICATIONS(::m_pUnk,@hNotificationsControlBlock)
RETURN self

* ---------

CLASS WebBrowser

  HIDDEN:
    VAR m_pUnk
    VAR m_EventsCookie
    VAR m_NotificationsCookie

  EXPORTED:
    VAR ExceptionCodeBlock
    METHOD init,Connect,Disconnect,GetPUnk
    METHOD Navigate

ENDCLASS

METHOD WebBrowser:init()
  ::m_pUnk:=0
  ::m_EventsCookie:=0
  ::m_NotificationsCookie:=0
  ::ExceptionCodeBlock:=NIL
RETURN self

METHOD WebBrowser:Connect(pObject)
  ::Disconnect()
  ::m_pUnk:=pObject
RETURN self

METHOD WebBrowser:Disconnect()
  JAXPPDELETECONTROL(::m_pUnk)
RETURN self

METHOD WebBrowser:GetPUnk()
RETURN ::m_pUnk

METHOD WebBrowser:Navigate(URL,hOptionalParameters)
  JAXPPCALLACTIVEXMETHODEX(::m_pUnk,104,1,0,@::ExceptionCodeBlock,hOptionalParameters,URL,8,2)
RETURN self

#endif

* ----------

// This function returns a different file name with each call,

STATIC FUNCTION _TempFileName( cPath, cExt )

LOCAL nSeconds := Seconds(), i, aDir

STATIC snCount := 0

LOCAL  cFileName

DO WHILE Seconds() - nSeconds < 100
  IF ++ snCount == 100
    snCount := 0
  ENDIF
  cFileName   := PadL( snCount, 2, "_" )    + ;
                 StrTran( Time(), ":", "" ) + cExt
  IF !File(cPath+cFileName)
    EXIT
  ENDIF
ENDDO

IF DC_PrintPreviewAcrobatOpt()[11]
  aDir := Directory( cPath + '*' + cExt )
  FOR i := 1 TO Len(aDir)
    FErase( cPath + aDir[i,1] )
  NEXT
ENDIF

RETURN cPath + cFileName

* ------------

#if XPPVER < 1900000

STATIC PROCEDURE ReflectEventToStatusText(hEvent)
LOCAL eventname
LOCAL status

 eventname=JAXPPGETEVENTNAME(hEvent)
 IF eventname="StatusTextChange"
   status=JAXPPGETEVENTPARAMETERVALUE(hEvent,"Text")
 END

RETURN

#endif

* -----------------

FUNCTION DC_PrinterName( cPrinterName )

STATIC scPrinterName
LOCAL cOldPrinterName := scPrinterName

IF Pcount() = 1
  scPrinterName := cPrinterName
ENDIF

RETURN cOldPrinterName

* -----------------

FUNCTION DC_PrinterPortToName( cPort )

LOCAL oPrinter, aPrinters, i, cPrinterName, cPortName

DEFAULT cPort := ''
cPort := Alltrim(Upper(cPort))
aPrinters := XbpPrinter():new():list()
IF Empty(aPrinters)
  RETURN ''
ENDIF
FOR i := 1 TO Len(aPrinters)
  oPrinter := XbpPrinter():new()
  oPrinter:create(aPrinters[i])
  cPortName := oPrinter:devPort
  oPrinter:destroy()
  DEFAULT cPortName := ''
  cPortName := Strtran(cPortName,':','')
  IF cPortName == cPort
    cPrinterName := aPrinters[i]
    EXIT
  ENDIF
NEXT

RETURN cPrinterName

* -----------------

FUNCTION DC_PrintImage( oXbp, nMode )

LOCAL aPos, i, oBitmap, oSourcePS, oPrinter, aTabPages[0]

DEFAULT nMode := 1

DCPRINT ON TO oPrinter ORIENTATION 2
IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
  RETURN .F.
ENDIF

IF nMode = 2 // Print all Tabpages

  LoadTabPages(oXbp, aTabPages)

  FOR i := 1 TO Len(aTabPages)

    oXbp := aTabPages[i]
    DC_TabActivate(oXbp,.t.)

    oSourcePS := oXbp:lockPS()

    oBitmap := GraSaveScreen( oSourcePS, {0,0}, oXbp:currentSize() )

    @ 0, 0 DCPRINT BITMAP oBitmap SCALE 2.4 PRINTER oPrinter

    @ 64,1 DCPRINT SAY 'Printed on ' + DtoC(Date()) + ' at ' + Time() ;
           PRINTER oPrinter

    IF i < Len(aTabPages)
      DCPRINT EJECT PRINTER oPrinter
    ENDIF
  NEXT

ELSE

  IF oXbp:isDerivedFrom('XbpDialog')
    aPos := { -3, -3 }
  ELSE
    aPos := { 0, 0 }
  ENDIF

  oSourcePS := oXbp:LockPS()
  oBitmap := GraSaveScreen( oSourcePS, aPos, oXbp:currentSize() )

  @ 0, 0 DCPRINT BITMAP oBitmap SCALE 2.4 PRINTER oPrinter

  @ 64,1 DCPRINT SAY 'Printed on ' + DtoC(Date()) + ' at ' + Time() ;
         PRINTER oPrinter

ENDIF

DCPRINT OFF PRINTER oPrinter

RETURN nil

* -------------

STATIC FUNCTION LoadTabPages( oXbp, aTabPages )

LOCAL i, aChildList := oXbp:childList()

FOR i := 1 TO Len(aChildList)

  oXbp := aChildList[i]
  IF oXbp:isDerivedFrom('XbpTabPage')
    AAdd( aTabPages, oXbp )
  ENDIF

  LoadTabPages( oXbp, aTabPages )

NEXT

RETURN nil

* -------------

GETSETFUNCTION DC_PrinterUsePenCoords DEFAULT .f.
